<?php
/*
Version: 1.3.2
Author: D.J.Gennoe
Author URI: http://www.web-uk.co.uk
*/
//*********************************************************************************
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

 function adminaddcss() 	{
	if (file_exists(THEME_PATH."/web-hosting/css/whadmin.css")){$url = (THEME_PATH."/web-hosting/css/whadmin.css"); wp_enqueue_style( 'whadminstyle', $url);
	 wp_register_style( 'adminaddcss', get_template_directory_uri() . '/whadminstyle.css', false, '1.0.0' );}
	else {
wp_enqueue_style( 'whadminstyle', plugins_url( '/web-hosting/css') . '/whadminstyle.css' );
			}

add_action('admin_enqueue_scripts', 'adminaddcss', 10);
		 
												}

	adminaddcss();




function wh_plugin_menu() {

	add_menu_page(__('Web Hosting'), __('Web Hosting'), 'manage_options' ,'wh_settings_page','wh_plugin_options');
	add_submenu_page('wh_settings_page', 'Hosting Settings', 'Hosting','manage_options', 'wh_settings_page','wh_plugin_options'); 
	add_submenu_page('wh_settings_page', __('Domains'), __('Domains'), 'manage_options', 'wh_domains_settings', 'wh_plugin_options2');
	add_submenu_page('wh_settings_page', __('Orders'), __('Orders'), 'manage_options', 'wh_orders_settings', 'wh_plugin_options3');
	add_submenu_page('wh_settings_page', __('Accounts'), __('Accounts'), 'manage_options', 'wh_account_settings', 'wh_plugin_options4');
											}
											add_action( 'admin_menu', 'wh_plugin_menu' );




function wh_plugin_options4(){
if ( !current_user_can( 'manage_options' ) ){
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
						}
	echo '<div class="wrap">';
	echo '<h2>Order Settings</h2>';
	echo '</div>';
	
    // Now display the settings editing screen
    echo '<div class="wrap">';
    // header
    echo "<h2>" . __( 'Customer Account Details', 'menu-test' ) . "</h2>";
    // settings form	
	
	
	// ************** Delete Hosting Account ***************************
	if( isset($_POST[ 'wh_account_delete' ]) && $_POST[ 'wh_account_delete' ] == 'Y' ) 
	{
		$retrieved_nonce = $_REQUEST['_wpnonce'];
		if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_account_confirm_delete' ) ) die( 'Sorry security token has expired' );
		$val_username = sanitize_text_field ($_POST[ 'wh_delete_account_username']);
		$val_choice = sanitize_text_field ($_POST[ 'Submit1']);
		
	if($val_choice =="Yes"){
	
	
	$opt_name_whm_hash = 'wh_whm_hash';
	$opt_name_whm_username = 'wh_whm_username';
	$opt_name_whm_ip = 'wh_whm_ip';

	
	$opt_val_whm_hash = get_option( $opt_name_whm_hash );
	$opt_val_whm_username =  get_option( $opt_name_whm_username );
	$opt_val_whm_ip =  get_option( $opt_name_whm_ip );
	

	$root_hash = $opt_val_whm_hash;
	$whm_username = $opt_val_whm_username;
	$ip = $opt_val_whm_ip;
	
	
	$xmlapi = new xmlapi($ip);
	$xmlapi->hash_auth($whm_username,$root_hash);
	$xmlapi->return_xml(1);
	$xmlapi->set_debug(1);

	
	$exit = 0;

$username = $val_username;
	$list = $xmlapi->removeacct($username, $keepdns = false);
	

	
	
	
	echo '<div class="whmessageboxgreen">Account ' . esc_html($val_username) . ' has been deleted</div>';

} else {echo 'Account ' .  esc_html($val_username) . ' has not been deleted';}
	}
	
	
	 if( isset($_POST[ 'wh_delete_account_hidden' ]) && $_POST[ 'wh_delete_account_hidden' ] == 'Y' ) 
	{
	$retrieved_nonce = $_REQUEST['_wpnonce'];
	if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_account_delete_form' ) ) die( 'Sorry security token has expired' );
	$val_username = sanitize_text_field ($_POST[ 'wh_delete_account_username']);

					?>
			
					<div id="admin_account_suspend_table">Confirm Deletion this cannot be undone<table><tr><td> 
					<form name="formconfirm" method="post" action="">
					<?php wp_nonce_field('wh_admin_account_confirm_delete'); ?>
					<input type="hidden" name="wh_delete_account_username" value="<?php echo esc_html($val_username); ?>">	
					<input type="hidden" name="wh_account_delete" value="Y">	
					<?php echo '<input type="submit" name="Submit1" class="wh_button-primary" value="Yes" /></td>';
					echo '<td><input type="submit" name="Submit2" class="wh_button-primary" value="No" /></td>';
					?></form></tr></table></div>
			
					<?php					
	
	
	}
	
	// ************** Suspend Hosting Account ***************************
	
	
	 if( isset($_POST[ 'wh_suspend_account_hidden' ]) && $_POST[ 'wh_suspend_account_hidden' ] == 'Y' ) 
	{
	$retrieved_nonce = $_REQUEST['_wpnonce'];
	if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_account_suspend_form' ) ) die( 'Sorry security token has expired' );
	$val_username = sanitize_text_field ($_POST[ 'wh_suspend_account_username']);

	$val_reason = sanitize_text_field ($_POST[ 'wh_suspend_reason']);
	update_option('wh_suspended_' . $val_username, $val_reason);

	
	
	$opt_name_whm_hash = 'wh_whm_hash';
	$opt_name_whm_username = 'wh_whm_username';
	$opt_name_whm_ip = 'wh_whm_ip';

	
	$opt_val_whm_hash = get_option( $opt_name_whm_hash );
	$opt_val_whm_username =  get_option( $opt_name_whm_username );
	$opt_val_whm_ip =  get_option( $opt_name_whm_ip );
	

	$root_hash = $opt_val_whm_hash;
	$whm_username = $opt_val_whm_username;
	$ip = $opt_val_whm_ip;
	
	
	$xmlapi = new xmlapi($ip);
	$xmlapi->hash_auth($whm_username,$root_hash);
	$xmlapi->return_xml(1);
	$xmlapi->set_debug(1);

	
	$exit = 0;

$username = $val_username;
	$list = $xmlapi->suspendacct($username, $reason = null);
	

	
	
	
	echo '<div class="whmessageboxgreen">Account ' . esc_html($val_username) . ' has been supended</div>';
	}
	
	
	// ************** Unsuspend Hosting Account ***************************
	
	 if( isset($_POST[ 'wh_unsuspend_account_hidden' ]) && $_POST[ 'wh_unsuspend_account_hidden' ] == 'Y' ) 
	{
	$retrieved_nonce = $_REQUEST['_wpnonce'];
	if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_account_unsuspend_form' ) ) die( 'Sorry security token has expired' );
	$val_username = sanitize_text_field ($_POST[ 'wh_unsuspend_account_username']);
	
	
	$opt_name_whm_hash = 'wh_whm_hash';
	$opt_name_whm_username = 'wh_whm_username';
	$opt_name_whm_ip = 'wh_whm_ip';

	
	$opt_val_whm_hash = get_option( $opt_name_whm_hash );
	$opt_val_whm_username =  get_option( $opt_name_whm_username );
	$opt_val_whm_ip =  get_option( $opt_name_whm_ip );
	

	$root_hash = $opt_val_whm_hash;
	$whm_username = $opt_val_whm_username;
	$ip = $opt_val_whm_ip;
	
	
	$xmlapi = new xmlapi($ip);
	$xmlapi->hash_auth($whm_username,$root_hash);
	$xmlapi->return_xml(1);
	$xmlapi->set_debug(1);

	
	$exit = 0;

$username = $val_username;
	$list = $xmlapi->unsuspendacct($username);
	

	
	
	
	echo '<div class="whmessageboxgreen">Account ' . esc_html($val_username) . ' has been unsupended</div>';
	delete_option('wh_suspended_' . $val_username);
	}
	
	

	
	
	 if( isset($_POST[ 'wh_submit_account_hidden' ]) && $_POST[ 'wh_submit_account_hidden' ] == 'Y' ) 
	{
	$retrieved_nonce = $_REQUEST['_wpnonce'];
	if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_account_edit_form' ) ) die( 'Sorry security token has expired' );
	$val_username = sanitize_text_field ($_POST[ 'wh_submit_account_username']);
	
	?>
	<div id="admin_account_suspend_table"><table><tr><th>
	<?php echo $val_username;?></th></tr><tr><td>
	
	<form name="form4" method="post" action="">
		<?php wp_nonce_field('wh_admin_account_suspend_form'); ?>
		<input type="hidden" name="wh_suspend_account_hidden" value="Y">
		<input type="hidden" name="wh_suspend_account_username" value="<?php echo esc_html($val_username); ?>">	
<input type="text" name="wh_suspend_reason"  value="" size="10">Reason for suspension		
		<?php echo '<input type="submit" name="Submit" class="wh_button-primary" value="Suspend Account" /></td>';
		?></form>
	<td>
	<form name="form5" method="post" action="">
		<?php wp_nonce_field('wh_admin_account_unsuspend_form'); ?>
		<input type="hidden" name="wh_unsuspend_account_hidden" value="Y">
		<input type="hidden" name="wh_unsuspend_account_username" value="<?php echo esc_html($val_username); ?>">				
		<?php echo '<input type="submit" name="Submit" class="wh_button-primary" value="Unsuspend Account" /></td>';
		?></form>
	<td>
	<form name="form6" method="post" action="">
		<?php wp_nonce_field('wh_admin_account_delete_form'); ?>
		<input type="hidden" name="wh_delete_account_hidden" value="Y">
		<input type="hidden" name="wh_delete_account_username" value="<?php echo esc_html($val_username); ?>">				
		<?php echo '<input type="submit" name="Submit" class="wh_button-primary" value="Delete Account" /></td>';
		?></form>
	
	</tr>
	
	
	
	</table></div>
	<?php
	
	
	}
	
	
	
	
	
	
$opt_name_whm_hash = 'wh_whm_hash';
$opt_name_whm_username = 'wh_whm_username';
$opt_name_whm_ip = 'wh_whm_ip';

	
	$opt_val_whm_hash = get_option( $opt_name_whm_hash );
	$opt_val_whm_username =  get_option( $opt_name_whm_username );
	$opt_val_whm_ip =  get_option( $opt_name_whm_ip );
	$root_hash = $opt_val_whm_hash;
	$whm_username = $opt_val_whm_username;
	$ip = $opt_val_whm_ip;
	
	
	$xmlapi = new xmlapi($ip);
	$xmlapi->hash_auth($whm_username,$root_hash);
	$xmlapi->return_xml(1);
	$xmlapi->set_debug(1);

	
	$exit = 0;
	$searchtype = 'ip'; 
	$search = $ip;
	$searchmethod = 'extact';
	$want = '';
	$list = $xmlapi->listaccts($searchtype,$search,$searchmethod,$want);

	$xml=simplexml_load_string($list);

?>
<h2> Current Accounts</h2>
<div id="admin_account_table"><table><tr><th>Username</th><th>Domain</th><th>Email</th><th>Disk Space</th><th>Disk Usage</th><th>Package</th><th>Status</th></tr><tr><?php
		
		$xml1 = json_decode(json_encode((array) simplexml_load_string($list)), 1);
		
		function sortuser($xml1, $xml1b) { return strcmp($xml1["user"], $xml1b["user"]);}
		usort($xml1['acct'], 'sortuser');
		
				foreach($xml1['acct'] as $key => $value)
			{
   				$a = $value['user'];
				$b = $value['domain'];
				$c = $value['email'];
				$d = $value['disklimit'];
				$e = $value['diskused'];
				$f = $value['plan'];
				$g = $value['suspended'];
				if($g == 0){$g = "Active";}else {$g = "suspended";}
			
					if ($a){
								?>
								<td><form name="form3" method="post" action="">
								<?php wp_nonce_field('wh_admin_account_edit_form'); ?>
								<input type="hidden" name="wh_submit_account_hidden" value="Y">
								<input type="hidden" name="wh_submit_account_username" value="<?php echo esc_html($a); ?>">				
								<?php echo '<input type="submit" name="Submit" class="wh_button-primary" value="' . esc_html($a) . '" /></form></td>' .  '<td>' . esc_html($b) . '</td>' .  '<td>' . esc_html($c) . '</td>' .  '<td>' . esc_html($d) . '</td>' .  '<td>' . esc_html($e) . '</td>' .  '<td>' . esc_html($f) . '</td>' .  '<td>' . esc_html($g) . '</td></form>';}
								echo '</tr><tr>';$th_count = 0;
								$count++;
							}
			
							?> </table></div><?php	
 
								}
											
function wh_plugin_options3(){
if ( !current_user_can( 'manage_options' ) ){
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
						}
	echo '<div class="wrap">';
	echo '<h2>Order Settings</h2>';
	echo '</div>';

 if( isset($_POST[ 'wh_submit_orders_hidden' ]) && $_POST[ 'wh_submit_orders_hidden' ] == 'Y' ) 
	{
	$retrieved_nonce = $_REQUEST['_wpnonce'];
	if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_orders_form' ) ) die( 'Sorry security token has expired' );
	$val_days = sanitize_text_field ($_POST[ 'days']);
 		if (ctype_digit($val_days)) {
if($val_days > '21'){$val_days = '21';}
		update_option( 'wh_order_days', $val_days );
		} else { _e( '<div class ="whmessageboxred"><b>Error Days:</b> Please only use numbers, please try again</div>' );$error=true;}


}
$val_days = get_option( 'wh_order_days', true );


	


    // Now display the settings editing screen
    echo '<div class="wrap">';
    // header
    echo "<h2>" . __( 'Customer Orders Settings', 'menu-test' ) . "</h2>";
    // settings form
        ?>
<b>Invoicing</b><br />
<table>
<form name="form2" method="post" action="">
<?php wp_nonce_field('wh_admin_orders_form'); ?>
<input type="hidden" name="wh_submit_orders_hidden" value="Y">

<tr>
<td>
<p><?php _e("Invoice:", 'menu-test' ); ?> 
<input type="text" name="days" pattern="[0-9]{1,2}" value="<?php echo  esc_attr( $val_days); ?>" size="5">Number of days in advance of order due date you want invoices sent out (max is 21 days)</p>
</td>
</tr>

</table>


<p class="submit">
<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
</p>
</form>
</div>
<?php
echo '<div class="wrap"><h2>Customers Orders</h2><br /></div>';
echo '<h3>Overdue Invoices</h3><br />';
global $overdueinvoices,$woocommerce,$order;
$overdue = get_option('wh_overdueinvoices',true);
?><table><?php
$overdue_invoices = false;
foreach ($overdue as $key => $value)
			{

if (get_post_status ( $key ) == 'trash'  ||  get_post_status ( $key ) == '' )
{
	if (get_post_status ( $key ) == '' )	{
	$overdue[$key] = false;
	update_option('wh_overdueinvoices',$overdue);
						}
}

else  	{
	$first_name = get_post_meta($key,'_billing_first_name',true);
	$last_name = get_post_meta($key,'_billing_last_name',true);

	$page = get_post($value);
	echo '<tr><td><h3>Order No ' . esc_html($key) . '</h3><h2> Customer ' . esc_html($first_name) . ' ' . esc_html($last_name) . '</td></tr><tr><td> Product ' . get_the_title($value)  . '</h2> <a href="' . get_site_url() . '/wp-admin/post.php?post=' . esc_html($key) .'&action=edit" target="_blank">View Order</a></b></td></tr>';
	$overdue_invoices = true;
	
	}
			}


?></table><?php
if ($overdue_invoices == false){echo '<h3>There are no overdue invoices</h3>';}
}

function wh_plugin_options2() 
{
	if ( !current_user_can( 'manage_options' ) ){
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
						}
	echo '<div class="wrap">';
	echo '<h2>Web Domain Settings</h2>';
	echo '</div>';



$number_of_tld = get_option( 'tlds');

$count = 0;
do
{
$count++;

$val_tld = get_option( 'wh_tld' . $count );
$val_tldprice = get_option( 'wh_tld' . $count . 'price' );

} while ($count < $number_of_tld);

   if( isset($_POST[ 'wh_submit_tld_hidden' ]) && $_POST[ 'wh_submit_tld_hidden' ] == 'Y' ) 
	{
        // Read their posted value


$retrieved_nonce = $_REQUEST['_wpnonce'];
if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_domains_form' ) ) die( 'Sorry security token has expired' );





	$val_tld0 = sanitize_text_field ($_POST[ 'tlds']);

 if (ctype_digit($val_tld0)) {

	update_option( 'tlds', $val_tld0 );
} else{ die( 'Please only submit numbers' );}


$number_of_tld = get_option( 'tlds');
$count = 0;
do
{
$count++;
	
	$tld = sanitize_text_field ($_POST[ 'tld' . $count]);
	$tld_price = sanitize_text_field ($_POST[ 'tld' . $count . 'price']);
	
	

$array[$tld] = $tld_price;

} while ($count < $number_of_tld);

ksort ($array);

$count = 0;





foreach ($array as $key => $val) {
$count++;
update_option( 'wh_tld' . $count, $key );
update_option( 'wh_tld' . $count . 'price', $val );
}
$array='';





?>
<div class="updated"><p><strong><?php _e('settings saved.', 'menu-test' ); ?></strong></p></div>
<?php
	}
    // Now display the settings editing screen
    echo '<div class="wrap">';
    // header
    echo "<h2>" . __( 'Top Level Domains', 'menu-test' ) . "</h2>";
    // settings form
        ?>
Top Level Domains you want to sell e.g. .biz .com<br />
<table>
<form name="form1" method="post" action="">
<?php wp_nonce_field('wh_admin_domains_form'); ?>
<input type="hidden" name="wh_submit_tld_hidden" value="Y">

<tr>
<td>
<p><?php _e("Number of TLD to sell:", 'menu-test' ); ?> 
<input type="text" name="tlds" pattern="[0-9]{1,2}" value="<?php echo  esc_attr( $number_of_tld); ?>" size="5"></p>
</td>
</tr>


<tr>
<td>TLD eg .biz
</td>
<td> Selling Price
</td>
</tr>
<?php
$number_of_tld = get_option( 'tlds');
if ($number_of_tld > 0){


$count = 0;

do
{
$count++;
$s = get_option( 'wh_tld' . $count);		
$val_tld = get_option( 'wh_tld' . $count . 'price');
?>
<tr>
<td>
<p><?php _e("TLD" . $count . ":", 'menu-test' ); ?>
<input type="text" name="tld<?php echo $count; ?>" pattern="[.]+[a-z\.]{1,32}" value="<?php echo esc_attr(  $s ); ?>" size="10"></p>
</td>
<td>
<p><?php _e("Price &nbsp;&pound;", 'menu-test' ); ?> 
<input type="text" name="tld<?php echo $count . 'price' ?>" pattern="[0-9]+\.[0-9]{2,2}$" value="<?php echo esc_attr( $val_tld ); ?>" size="5"></p>
</td>
</tr>
<?php
} while ($count < $number_of_tld );

}



?>

<hr />
<p class="submit">
<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
</p>
</form>
</table>
</div>
<?php
}
function wh_plugin_options() {
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}
	echo '<div class="wrap">';
	echo '<h2>Web Hosting Settings</h2>';
	echo '</div>';
$opt_name_id = 'wh_reseller_id';
$opt_name_api = 'wh_reseller_api';
$opt_name_whm_hash = 'wh_whm_hash';
$opt_name_whm_servername = 'wh_whm_servername';
$opt_name_whm_username = 'wh_whm_username';
$opt_name_whm_ip = 'wh_whm_ip';
$opt_name_whm_ip_address = 'wh_whm_ip_address';
$opt_name_whm_port = 'wh_whm_port';
$opt_name_whm_cp_port = 'wh_whm_cp_port';
$opt_name_hostingpage = 'wh_hostingpage';
$opt_name_addonspage = 'wh_addonspage';
$opt_name_domainspage = 'wh_domainspage';
$opt_name_shoppingpage = 'wh_shoppingpage';
$opt_name_nameserver01 = 'wh_nameserver01';
$opt_name_nameserver02 = 'wh_nameserver02';
$opt_name_nameserver03 = 'wh_nameserver03';
$opt_name_nameserver04 = 'wh_nameserver04';
$opt_name_checkbox = 'wh_checkbox';
$opt_name_companyname = 'wh_companyname';
$opt_name_companyaddress01 = 'wh_companyaddress01';
$opt_name_companyaddress02 = 'wh_companyaddress02';
$opt_name_companycity = 'wh_companycity';
$opt_name_companystate = 'wh_companystate';
$opt_name_companypostcode = 'wh_companypostcode';
$opt_name_companyphone = 'wh_companyphone';



    $hidden_field_name = 'mt_submit_hidden';
	$data_field_id = 'wh_reseller_id';
	$data_field_api = 'wh_api_key';
	$data_field_whm_hash = 'wh_whm_hash';
	$data_field_whm_servername = 'wh_whm_servername';
	$data_field_whm_username = 'wh_whm_username';
	$data_field_whm_ip = 'wh_whm_ip';
	$data_field_whm_ip_address = 'wh_whm_ip_address';
	$data_field_whm_port = 'wh_whm_port';
	$data_field_whm_cp_port = 'wh_whm_cp_port';
	$data_field_hostingpage = 'wh_hostingpage';
	$data_field_addonspage = 'wh_addonspage';
	$data_field_domainspage = 'wh_domainspage';
	$data_field_shoppingpage = 'wh_shoppingpage';
	$data_field_nameserver01 = 'wh_nameserver01';
	$data_field_nameserver02 = 'wh_nameserver02';
	$data_field_nameserver03 = 'wh_nameserver03';
	$data_field_nameserver04 = 'wh_nameserver04';
	$data_field_checkbox = 'wh_checkbox';

	$data_field_companyname = 'wh_companyname';
	$data_field_companyaddress01 = 'wh_companyaddress01';
	$data_field_companyaddress02 = 'wh_companyaddress02';
	$data_field_companycity = 'wh_companycity';
	$data_field_companystate = 'wh_companystate';
	$data_field_companypostcode = 'wh_companypostcode';
	$data_field_companyphone = 'wh_companyphone';




    // Read in existing option value from database
    $opt_val_id = get_option( $opt_name_id );
 $opt_val_api = get_option( $opt_name_api );
 $opt_val_whm_hash = get_option( $opt_name_whm_hash );
 $opt_val_whm_servername = get_option( $opt_name_whm_servername );
 $opt_val_whm_username = get_option( $opt_name_whm_username );
 $opt_val_whm_ip = get_option( $opt_name_whm_ip );
$opt_val_whm_ip_address = get_option( $opt_name_whm_ip_address );
$opt_val_whm_port = get_option( $opt_name_whm_port );
$opt_val_whm_cp_port = get_option( $opt_name_whm_cp_port );
$opt_val_hostingpage = get_option( $opt_name_hostingpage );
$opt_val_addonspage = get_option( $opt_name_addonspage );
$opt_val_domainspage = get_option( $opt_name_domainspage );
$opt_val_shoppingpage = get_option( $opt_name_shoppingpage );
$opt_val_nameserver01 = get_option( $opt_name_nameserver01 );
$opt_val_nameserver02 = get_option( $opt_name_nameserver02 );
$opt_val_nameserver03 = get_option( $opt_name_nameserver03 );
$opt_val_nameserver04 = get_option( $opt_name_nameserver04 );
$opt_val_checkbox = get_option( $opt_name_checkbox );

$opt_val_companyname = get_option( $opt_name_companyname );
$opt_val_companyaddress01 = get_option( $opt_name_companyaddress01 );
$opt_val_companyaddress02 = get_option( $opt_name_companyaddress02 );
$opt_val_companycity = get_option( $opt_name_companycity );
$opt_val_companystate = get_option( $opt_name_companystate );
$opt_val_companypostcode = get_option( $opt_name_companypostcode );
$opt_val_companyphone = get_option( $opt_name_companyphone );







    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {

$retrieved_nonce = $_REQUEST['_wpnonce'];
if (!wp_verify_nonce($retrieved_nonce, 'wh_admin_hosting_form' ) ) die( 'Sorry security token has expired' );

$error=false;

        // Read their posted value
        $opt_val_id = sanitize_text_field ($_POST[ $data_field_id ]);
        // Save the posted value in the database
if (ctype_digit($opt_val_id)) {
        update_option( $opt_name_id, $opt_val_id );
}else{ _e( '<div class ="whmessageboxred"><b>Error Reseller id:</b> Please only use numbers, please try again</div>' );$error=true;}
        // Read their posted value
        $opt_val_api = sanitize_text_field ($_POST[ $data_field_api ]);
        // Save the posted value in the database
if (ctype_alnum($opt_val_api)) {
        update_option( $opt_name_api, $opt_val_api );
}else{ _e( '<div class ="whmessageboxred"><b>Error Api Key:</b> Please only use alphanumeric characters (Letters and numbers) please try again</div>' );$error=true;}


  	$opt_val_whm_hash = sanitize_text_field($_POST[ $data_field_whm_hash ]);
        // Save the posted value in the database
$trimmed = trim($opt_val_whm_hash," \r\n");$opt_val_whm_hash = $trimmed;
$trimmed = str_replace(' ', '', $opt_val_whm_hash);$opt_val_whm_hash = $trimmed;

if (ctype_alnum($opt_val_whm_hash)) {
        update_option( $opt_name_whm_hash, $opt_val_whm_hash );
}else{ _e( '<div class ="whmessageboxred"><b>Error WHM Hash Key:</b> Please only use alphanumeric characters (Letters and numbers) please try again</div>' );$error=true;}


 	$opt_val_whm_servername = sanitize_text_field ($_POST[ $data_field_whm_servername ]);
	// Save the posted value in the database
        update_option( $opt_name_whm_servername, $opt_val_whm_servername );

	 $opt_val_whm_username = sanitize_text_field ($_POST[ $data_field_whm_username ]);
        // Save the posted value in the database
        update_option( $opt_name_whm_username, $opt_val_whm_username );

 	$opt_val_whm_ip = sanitize_text_field ($_POST[ $data_field_whm_ip ]);
        // Save the posted value in the database

if (!filter_var($opt_val_whm_ip, FILTER_VALIDATE_IP) === false) {
    update_option( $opt_name_whm_ip, $opt_val_whm_ip );
} else { _e( '<div class ="whmessageboxred"><b>Error WHM ip address:</b> Please only use format 127.0.4.1 please try again</div>' );$error=true;}




        

	$opt_val_whm_ip_address = sanitize_text_field ($_POST[ $data_field_whm_ip_address ]);
        // Save the posted value in the database
        update_option( $opt_name_whm_ip_address, $opt_val_whm_ip_address );

	$opt_val_whm_port = sanitize_text_field ($_POST[ $data_field_whm_port ]);
        // Save the posted value in the database
if (ctype_digit($opt_val_whm_port)) {
        update_option( $opt_name_whm_port, $opt_val_whm_port );
}
else{ _e( '<div class ="whmessageboxred"><b>Error WHM Server Port:</b> Please only use numbers please try again</div>' );$error=true;}

	$opt_val_whm_cp_port = sanitize_text_field ($_POST[ $data_field_whm_cp_port ]);
	// Save the posted value in the database
if (ctype_digit($opt_val_whm_cp_port)) {
	update_option( $opt_name_whm_cp_port, $opt_val_whm_cp_port );
}
else{ _e( '<div class ="whmessageboxred"><b>Error Cpanel Port:</b> Please only use numbers please try again</div>' );$error=true;}

	$opt_val_hostingpage = sanitize_text_field ($_POST[ $data_field_hostingpage ]);
        // Save the posted value in the database
        update_option( $opt_name_hostingpage, $opt_val_hostingpage );
	$opt_val_addonspage = sanitize_text_field ($_POST[ $data_field_addonspage ]);
        // Save the posted value in the database
        update_option( $opt_name_addonspage, $opt_val_addonspage );
	$opt_val_domainspage = sanitize_text_field ($_POST[ $data_field_domainspage ]);
        // Save the posted value in the database
        update_option( $opt_name_domainspage, $opt_val_domainspage );
	$opt_val_shoppingpage = sanitize_text_field ($_POST[ $data_field_shoppingpage ]);
        // Save the posted value in the database
        update_option( $opt_name_shoppingpage, $opt_val_shoppingpage );
  

$opt_val_nameserver01 = sanitize_text_field ($_POST[ $data_field_nameserver01 ]);
        // Save the posted value in the database
 if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $opt_val_nameserver01)) 
	{ echo '<div class ="whmessageboxred">Error nameserver 01 has not been updated incorrect format used</div>';$error=true;}
else {update_option( $opt_name_nameserver01, $opt_val_nameserver01 );}

$opt_val_nameserver02 = sanitize_text_field ($_POST[ $data_field_nameserver02 ]);
        // Save the posted value in the database
if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $opt_val_nameserver02)) 
	{ echo '<div class ="whmessageboxred">Error nameserver 02 has not been updated incorrect format used</div>';$error=true;}
else {update_option( $opt_name_nameserver02, $opt_val_nameserver02 );}

$opt_val_nameserver03 = sanitize_text_field ($_POST[ $data_field_nameserver03 ]);
        // Save the posted value in the database
if ($opt_val_nameserver03){
if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $opt_val_nameserver03)) 
	{ echo '<div class ="whmessageboxred">Error nameserver 03 has not been updated incorrect format used</div>';$error=true;}
else {update_option( $opt_name_nameserver03, $opt_val_nameserver03 );}
}
$opt_val_nameserver04 = sanitize_text_field ($_POST[ $data_field_nameserver04 ]);
        // Save the posted value in the database
if ($opt_val_nameserver03){
if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $opt_val_nameserver04)) 
	{ echo '<div class ="whmessageboxred">Error nameserver 04 has not been updated incorrect format used</div>';$error=true;}
else {update_option( $opt_name_nameserver04, $opt_val_nameserver04 );}
}
$opt_val_checkbox = sanitize_text_field ($_POST[ $data_field_checkbox ]);
        // Save the posted value in the database
        update_option( $opt_name_checkbox, $opt_val_checkbox );

$opt_val_companyname = sanitize_text_field ($_POST[ $data_field_companyname ]);
        // Save the posted value in the database

 if(!preg_match('/^[a-z0-9 \-]+$/i', $opt_val_companyname)){
echo '<div class ="whmessageboxred">Error Company Name: has not been updated please only use letters, numbers and spaces </div>';$error=true;
}
else{
        update_option( $opt_name_companyname, $opt_val_companyname );
}
$opt_val_companyaddress01 = sanitize_text_field ($_POST[ $data_field_companyaddress01 ]);
        // Save the posted value in the database
 if(!preg_match('/^[a-zA-Z0-9 \-]+$/i', $opt_val_companyaddress01)){
echo '<div class ="whmessageboxred">Error Company Address 1: has not been updated please only use letters, numbers,hyphens and spaces </div>';$error=true;
}
else{
        update_option( $opt_name_companyaddress01, $opt_val_companyaddress01 );
}

$opt_val_companyaddress02 = sanitize_text_field ($_POST[ $data_field_companyaddress02 ]);
        // Save the posted value in the database
 if(!preg_match('/^[a-zA-Z0-9 \-]+$/i', $opt_val_companyaddress02)){
echo '<div class ="whmessageboxred">Error Company Address 2: has not been updated please only use letters, numbers,hyphens and spaces </div>';$error=true;
}
else{
        update_option( $opt_name_companyaddress02, $opt_val_companyaddress02 );
}

$opt_val_companycity = sanitize_text_field ($_POST[ $data_field_companycity ]);
        // Save the posted value in the database
 if(!preg_match('/^[a-zA-Z \.-]+$/i', $opt_val_companycity)){
echo '<div class ="whmessageboxred">Error Company City: has not been updated please only use letters,periods,hyphens and spaces </div>';$error=true;
}
else{
        update_option( $opt_name_companycity, $opt_val_companycity );
}

$opt_val_companystate = sanitize_text_field ($_POST[ $data_field_companystate ]);
        // Save the posted value in the database
 if(!preg_match('/^[a-zA-Z\ ]+$/i', $opt_val_companystate)){
echo '<div class ="whmessageboxred">Error Company State: has not been updated please only use letters and spaces </div>';$error=true;
}
else{
        update_option( $opt_name_companystate, $opt_val_companystate );
}

$opt_val_companypostcode = sanitize_text_field ($_POST[ $data_field_companypostcode ]);
        // Save the posted value in the database


$postcode = strtoupper(str_replace(' ','',$opt_val_companypostcode));
    if(preg_match("/^[A-Z]{1,2}[0-9]{2,3}[A-Z]{2}$/",$postcode) || preg_match("/^[A-Z]{1,2}[0-9]{1}[A-Z]{1}[0-9]{1}[A-Z]{2}$/",$postcode) || preg_match("/^GIR0[A-Z]{2}$/",$postcode))
    {
         update_option( $opt_name_companypostcode, $opt_val_companypostcode );
    }
    else
    {
        echo '<div class ="whmessageboxred">Error Postcode: has not been updated incorrect format used TZ15 0ZZ </div>';$error=true;

    }



       

$opt_val_companyphone = sanitize_text_field ($_POST[ $data_field_companyphone ]);
        // Save the posted value in the database




 if(!preg_match('/^[\d ]+$/i', $opt_val_companyphone))
    {
      echo '<div class ="whmessageboxred">Error Telephone: has not been updated please use just numbers and spaces</div>';$error=true;

    }
        
else
    {
      update_option( $opt_name_companyphone, $opt_val_companyphone );  
    }

       // Put a "settings saved" message on the screen



if ($error==false){
?>
<div class="updated"><p><strong><?php _e('settings saved.', 'menu-test' ); ?></strong></p></div>
<?php
}
    }
    // Now display the settings editing screen
    echo '<div class="wrap">';
    // header
    echo "<h2>" . __( 'ResellerClub', 'menu-test' ) . "</h2>";
    // settings form
        ?>

<form name="form1" method="post" action="">
<?php wp_nonce_field('wh_admin_hosting_form'); ?>
<input type="hidden" name="<?php echo  esc_attr( $hidden_field_name ); ?>" value="Y">
<p><?php _e("Reseller id:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_id ); ?>" pattern="[0-9]{6}|[0-9]{8}" value="<?php echo esc_attr( $opt_val_id ); ?>" size="20"> 6 or 8 digit Number
<?php if ($opt_val_id == ''){


$resellercluburl = 'http://uk.resellerclub.com/signup-now';
?>
<a href="<?php echo esc_url( $resellercluburl ) ?>" target="_blank">Get a Resellerclub account</a>



<?php }?></p><hr />
<p><?php _e("Api Key:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_api ); ?>" value="<?php echo esc_attr( $opt_val_api); ?>" size="34"> Letters and Numbers only</p>


<p><?php _e("Nameserver01:", 'menu-test' ); ?> 
<input type="text" name="<?php echo  esc_attr( $data_field_nameserver01 ); ?>" value="<?php echo  esc_attr( $opt_val_nameserver01) ; ?>" size="20"> Format ns1.example.com</p>

<p><?php _e("Nameserver02:", 'menu-test' ); ?> 
<input type="text" name="<?php echo  esc_attr( $data_field_nameserver02 ); ?>" value="<?php echo esc_attr( $opt_val_nameserver02 ); ?>" size="20"> Format ns2.example.com</p>

<p><?php _e("Nameserver03:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_nameserver03 ); ?>" value="<?php echo esc_attr( $opt_val_nameserver03 ); ?>" size="20"> Format ns3.example.com</p>

<p><?php _e("Nameserver04:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_nameserver04 ); ?>" value="<?php echo esc_attr( $opt_val_nameserver04 ); ?>" size="20"> Format ns4.example.com</p>
<hr><?php


if ($opt_val_checkbox == 'yes'){ $checked = 'checked';}?>
<p><?php _e("Resellerclub Demo:", 'menu-test' ); ?> 
<input type="checkbox" name="<?php echo esc_attr( $data_field_checkbox ); ?>" value="yes" <?php echo esc_attr( $checked ); ?> >Check this if you are using Resellerclub Demo Site</p>


<hr>

<h2> WHM </h2>
<hr />
<p><?php _e("WHM username:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_whm_username ); ?>" value="<?php echo esc_attr( $opt_val_whm_username ); ?>"size="20"></p>
<p><?php _e("WHM Hash Key:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_whm_hash ); ?>" value="<?php echo esc_attr( $opt_val_whm_hash ); ?>" size="100"></p>

<p><?php _e("WHM ip address:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_whm_ip ); ?>" value="<?php echo esc_attr( $opt_val_whm_ip ); ?>" size="16">e.g. 100.50.5.10</p>

<p><?php _e("WHM server address:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_whm_ip_address ); ?>" value="<?php echo esc_attr( $opt_val_whm_ip_address ); ?>" size="16">e.g. cloud500.web-uk.co.uk or can be WHM ip address as above</p>

<p><?php _e("WHM Server Name:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_whm_servername ); ?>" value="<?php echo esc_attr( $opt_val_whm_servername ); ?>" size="20">e.g. cloud500</p>
<p><?php _e("WHM Server Port:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_whm_port ); ?>" value="<?php echo esc_attr( $opt_val_whm_port ); ?>" size="20"> Port used by your server to access WHM e.g. 2087</p>
<p><?php _e("Cpanel Port:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_whm_cp_port ); ?>" value="<?php echo esc_attr( $opt_val_whm_cp_port ); ?>" size="20"> Port used by your server to access Cpanel e.g. 2083</p>







<h2> Call To Action Buttons </h2>
<h3> My-Account page</h3>

<p><b> Domains</b></p>
<p><?php _e("Domains Page:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_domainspage ); ?>" value="<?php echo esc_attr( $opt_val_domainspage ); ?>" size="20"> page URL where your Domain Checker Form is displayed e.g. /domain-checker/</p>

<b> Hosting Packages</b>
<p><?php _e("Hosting Packages Page:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_hostingpage ); ?>" value="<?php echo esc_attr( $opt_val_hostingpage ); ?>" size="20"> page URL where your hosting packages are displayed e.g. /web-hosting/</p>

<p><b> Addons</b></p>
<p><?php _e("Addons Page:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_addonspage ); ?>" value="<?php echo esc_attr( $opt_val_addonspage ); ?>" size="20"> page URL where your Addons are displayed e.g. /addons/</p>

<p><b>Continue Shopping Button In Cart</b></p>
<p><?php _e("Continue Shopping Page:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_shoppingpage ); ?>" value="<?php echo esc_attr( $opt_val_shoppingpage ); ?>" size="20"> page URL where your products are displayed e.g. /shop/</p>


<hr />

<h2> Company Details </h2>



<p><?php _e("Company Name:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_companyname ); ?>" value="<?php echo esc_attr( $opt_val_companyname ); ?>" size="20"> Company name to be displayed on invoices</p>


<p><?php _e("Company Address 1:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_companyaddress01 ); ?>" value="<?php echo esc_attr( $opt_val_companyaddress01 ); ?>" size="20"> First line of address</p>

<p><?php _e("Company Address 2:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_companyaddress02 ); ?>" value="<?php echo esc_attr( $opt_val_companyaddress02 ); ?>" size="20"> Second line of address</p>

<p><?php _e("City:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_companycity ); ?>" value="<?php echo esc_attr( $opt_val_companycity ); ?>" size="20"> City</p>

<p><?php _e("State:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_companystate ); ?>" value="<?php echo esc_attr( $opt_val_companystate ); ?>" size="20"> State</p>

<p><?php _e("Postcode:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_companypostcode ); ?>" value="<?php echo esc_attr( $opt_val_companypostcode ); ?>" size="20"> Postcode</p>

<p><?php _e("Telephone:", 'menu-test' ); ?> 
<input type="text" name="<?php echo esc_attr( $data_field_companyphone ); ?>" value="<?php echo esc_attr( $opt_val_companyphone ); ?>" size="20"> Telephone Number</p>




<p class="submit">
<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
</p>
</form>
</div>
<?php
}