<?php
/*
Plugin Name: Web Hosting
Plugin URI: http://www.web-uk.co.uk/wp_plugins/web-hosting/
Description: Web Hosting plugin using resellerclub and WHM.
Version: 1.3.2
Author: D.J.Gennoe
Author URI: http://www.web-uk.co.uk
*/
//*********************************************************************************

defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
define('WH_PATH', plugin_dir_path(__FILE__));
$wh_themepath = get_stylesheet_directory();
$wh_themepathurl = get_stylesheet_directory_uri();
define('THEME_PATH', $wh_themepath);
define('THEME_PATH_URL', $wh_themepathurl);
if (file_exists(THEME_PATH."/web-hosting/includes/options.php")){require_once (THEME_PATH."/web-hosting/includes/options.php" );}
else{
require_once (WH_PATH."/includes/options.php" );
}

if (file_exists(THEME_PATH."/web-hosting/wh_functions.php")){require_once (THEME_PATH."/web-hosting/wh_functions.php" );}
else{
require_once (WH_PATH."wh_functions.php" );
}

if (file_exists(THEME_PATH."/web-hosting/wh_globals.php")){require_once (THEME_PATH."/web-hosting/wh_globals.php" );}
else{
require_once (WH_PATH."wh_globals.php" );
}

if (file_exists(THEME_PATH."/web-hosting/includes/tcpdf/config/lang/eng.php")){require_once (THEME_PATH."/web-hosting/includes/tcpdf/config/lang/eng.php" );}
else{
require_once (WH_PATH."/includes/tcpdf/config/lang/eng.php" );
}

if (file_exists(THEME_PATH."/web-hosting/includes/tcpdf/tcpdf.php")){require_once (THEME_PATH."/web-hosting/includes/tcpdf/tcpdf.php" );}
else{
require_once (WH_PATH."/includes/tcpdf/tcpdf.php" );
}

if (file_exists(THEME_PATH."/web-hosting/includes/tcpdf_class.php")){require_once (THEME_PATH."/web-hosting/includes/tcpdf_class.php" );}
else{
require_once (WH_PATH."/includes/tcpdf_class.php" );
}

if (file_exists(THEME_PATH."/web-hosting/includes/phpmailer/PHPMailerAutoload.php")){require_once (THEME_PATH."/web-hosting/includes/phpmailer/PHPMailerAutoload.php" );}
else{
require_once (WH_PATH."/includes/phpmailer/PHPMailerAutoload.php" );
}

if (file_exists(THEME_PATH."/web-hosting/includes/widget.php")){require_once (THEME_PATH."/web-hosting/includes/widget.php" );}
else{
require_once (WH_PATH."/includes/widget.php" );
}

function addcss() {
	if (file_exists(THEME_PATH."/web-hosting/css/whstyle.css")){$url = (THEME_PATH_URL."/web-hosting/css/whstyle.css"); wp_enqueue_style( 'whstyle', $url);}
	else {
wp_enqueue_style( 'whstyle', plugins_url( '/web-hosting/css') . '/whstyle.css' );
}
}
add_action('wp_enqueue_scripts', 'addcss', 11);

include(WH_PATH.'/includes/xmlapi.php' );

if ( is_admin() ) {
     // We are in admin mode
	 	 if (file_exists(THEME_PATH."/web-hosting/includes/admin.php")){require_once (THEME_PATH."/web-hosting/includes/admin.php" );}
		  else
{
require_once (WH_PATH."/includes/admin.php" );
}

						}


add_filter('widget_text', 'do_shortcode');
addcss();
$rc_url = false;
if (isset($wh_checkbox) && ($wh_checkbox == 'yes')){$rc_url = 'test.';}
?>