<?php
// ***** version 1.3.2 *****



// create a scheduled event (if it does not exist already)
function wh_cronstarter_activation() {
	if( !wp_next_scheduled( 'wh_check_invoices' ) ) {  
	   wp_schedule_event( time(), 'daily', 'wh_check_invoices' );  
	}
}
// and make sure it's called whenever WordPress loads
add_action('wp', 'wh_cronstarter_activation');





// unschedule event upon plugin deactivation
function wh_cronstarter_deactivate() {	
	// find out when the last event was scheduled
	$timestamp = wp_next_scheduled ('wh_check_invoices');
	// unschedule previous event if any
	wp_unschedule_event ($timestamp, 'wh_check_invoices');
} 
register_deactivation_hook (__FILE__, 'wh_cronstarter_deactivate');




// here's the function we'd like to call with our cron job
function wh_subscriptions_function() {
	
	wh_send_domain_renew_emails();
	wh_subscriptions();
	
}

// hook that function onto our scheduled event:
add_action ('wh_check_invoices', 'wh_subscriptions_function'); 


function wh_transfer_domain_form()
{
ob_start();
global $fulldomainname, $domaintld, $years, $new_post_id, $new_or_transfer, $auth_code,
$domaincheckmessage,$domainname,$data_tld1,$transferstatus,$tld,$httpResponse,$transfer_error;
goto whjump;
	if (isset($_POST['transfercheck']) && isset($_POST['transferdomain'])) 
	{

$retrieved_nonce = $_REQUEST['_wpnonce'];
if (!wp_verify_nonce($retrieved_nonce, 'wh_transfer' ) ) die( 'Sorry security token has expired' );
$show_reg_form = false;

	$domaintld = '.' . $tld;
	
	$new_or_transfer = 'transfer';
	$years = sanitize_text_field($_POST['years']);
if ($years == 'Number of Years'){$years = '1'; }
$numberofyears = substr($years, 0,1);
	$fulldomainname = sanitize_text_field($_POST['transferdomain']);

	$tempurl = 'http://www.' . $fulldomainname;
	$tempurl = filter_var($tempurl, FILTER_SANITIZE_URL);
		if (filter_var($tempurl, FILTER_VALIDATE_URL) == true) {
		 
		} 
		else {
			
		$domaincheckmessage = esc_html($fulldomainname . ' is not a valid URL');
		goto WHERROR;
		}
		$auth_code = sanitize_text_field($_POST['authcode']);
		$fullstring = $fulldomainname;
		$finddot   = '.';
		$fulllen = strlen($fulldomainname);
		$len = strpos($fullstring, $finddot);
if ($len === false){$domaincheckmessage = esc_html ($fulldomainname . ' is not a valid URL');goto WHERROR;}
		$lastbit = $fulllen - $len;
		$firstbit = substr($fulldomainname, 0, -$lastbit);
		$tld = substr($fulldomainname, $len+1);$fulltld == false;
		$fulltld = substr($fulldomainname, $len);
		$fulltldlen = strlen($fulltld);
		if ($fulltldlen <3){$domaincheckmessage = esc_html ($fulldomainname . ' is not a valid URL');goto WHERROR;}
		$domainname = $firstbit;
	domain_checker($httpResponse,$domainname);
	$domaintld = '.' . $tld;
	process_domain_name($httpResponse,$domainstatus);

		if ($transferstatus == true)
		{
		wh_get_number_of_tld($data_tld1);
			foreach( $data_tld1 as $key => $value)
			{
				if ($key == $domaintld)
				{
				$price1 =  htmlentities ($value, ENT_QUOTES, 'UTF-8') *  htmlentities ($numberofyears, ENT_QUOTES, 'UTF-8') ;
				
				}
			}
$tld = $fulltld;
	wh_create_domain_product($fulldomainname, $domaintld, $years, $new_post_id);
		update_post_meta( $new_post_id, '_price', $price1 );
		update_post_meta( $new_post_id, '_regular_price', $price1 );
		update_post_meta( $new_post_id, '_new-or-transfer', $new_or_transfer );
		update_post_meta( $new_post_id, '_auth-code', $auth_code );
		$path2 = $_SERVER['REQUEST_URI'];
?>
<div class="whmessageboxgreen"> <?php echo esc_html ($domaincheckmessage, ENT_QUOTES, 'UTF-8' ) . ' for ' . esc_html($years) . ' &nbsp;Cost &pound;' . esc_html($price1)  ;?> </div><?php

?><div class="wh_button"><a href="<?php echo esc_html ('?add-to-cart=' . $new_post_id, ENT_QUOTES, 'UTF-8');?>">Add to basket </a></div>
	<?php

goto whtransfer_end;
	}
else
{
WHERROR:
?><div class="whmessageboxred"> <?php echo esc_html ($domaincheckmessage, ENT_QUOTES, 'UTF-8') ;?> </div><?php
$show_reg_form = true;

}
}
// if($show_reg_form == false){
	whjump:
	$domain_page = get_option( 'wh_domainspage', true );
	$siteurl = get_home_url();
	?>
	
	
<form action="<?php echo esc_attr ($siteurl) . esc_attr ($domain_page);?>" method="post">
<?php wp_nonce_field('wh_transfer'); ?>



<table class="transfer_domain_form_table">
<thead>
<tr>
<th>Transfer Domain Name</th>

		<th><input name="transferdomain" type="text" pattern="[a-z0-9.-]+\.[a-z]{2,3}$" value=""/></th>

				<th>		<select name="years"><option>Number of Years</option>
				<option>1 Year</option>
				<option>2 Years</option>
				<option>3 Years</option>
				<option>4 Years</option>
				<option>5 Years</option>
				</select></th>
</tr>
</thead>
<tbody>
<tr>
							<th>		Auth Code	<input name="authcode" type="text" value="" /></th>
					
<th>Auth Code is required for the following TLDs (extensions) You can leave this here blank and submit the code at a later date.
</th>

<th>

<select name="tldS"><option>TLDs</option>
<option>.AU</option>
<option>.BIZ</option>
<option>.BZ</option>
<option>.CA</option>
<option>.CO</option>
<option>.COM</option>
<option>.DE</option>
<option>.EU</option>
<option>.IN</option>
<option>.IND.IN</option>
<option>.INFO</option>
<option>.MN</option>
<option>.MOBI</option>
<option>.NAME</option>
<option>.NET</option>
<option>.NL</option>
<option>.NZ</option>
<option>.ORG</option>
<option>.US</option>
<option>.WS</option>
<option>.XXX</option>
</select>



</th>


</tr>
<tr>
<th>
		
			
			<input name="transfercheck" type="submit" value="Go" />
			
</th><th> </th><th> </th></tr>	
	</tbody>

</table>

</form>
	
	<?php

			
whtransfer_end:
$output_string=ob_get_contents();
ob_end_clean();

return $output_string;
}
add_shortcode('wh_transfer_domain_form','wh_transfer_domain_form');





function check_domain_name()
{
global $httpResponse,$domainname,$tld,$domainstatus,$fulldomainname,$new_post_id,$woocommerce,$error;
global $contact_type_tld, $numberofyears,$newprice,$domaintld,$years;	

global $new_or_transfer, $auth_code,$domaincheckmessage,$data_tld1,$transferstatus,$transfer_error;

if (isset($_POST['transfercheck']) && isset($_POST['transferdomain'])){
	$retrieved_nonce = $_REQUEST['_wpnonce'];
if (!wp_verify_nonce($retrieved_nonce, 'wh_transfer' ) ) die( 'Sorry security token has expired' );



$show_reg_form = false;

	$domaintld = '.' . $tld;
	
	$new_or_transfer = 'transfer';
	$years = sanitize_text_field($_POST['years']);

	
if ($years == 'Number of Years'){$years = '1'; }
$numberofyears = substr($years, 0,1);
	$fulldomainname = sanitize_text_field($_POST['transferdomain']);

	$tempurl = 'http://www.' . $fulldomainname;
	$tempurl = filter_var($tempurl, FILTER_SANITIZE_URL);
		if (filter_var($tempurl, FILTER_VALIDATE_URL) == true) {
		 
		} 
		else {
			
		$domaincheckmessage = esc_html($fulldomainname . ' is not a valid URL');
		goto ERROR;
		}
		$auth_code = sanitize_text_field($_POST['authcode']);
		$fullstring = $fulldomainname;
		$finddot   = '.';
		$fulllen = strlen($fulldomainname);
		$len = strpos($fullstring, $finddot);
if ($len === false){$domaincheckmessage = esc_html ($fulldomainname . ' is not a valid URL');goto ERROR;}
		$lastbit = $fulllen - $len;
		$firstbit = substr($fulldomainname, 0, -$lastbit);
		$tld = substr($fulldomainname, $len+1);$fulltld == false;
		$fulltld = substr($fulldomainname, $len);
		$fulltldlen = strlen($fulltld);
		if ($fulltldlen <3){$domaincheckmessage = esc_html ($fulldomainname . ' is not a valid URL');goto ERROR;}
		$domainname = $firstbit;
	domain_checker($httpResponse,$domainname);
	$domaintld = '.' . $tld;
	process_domain_name($httpResponse,$domainstatus);

		if ($transferstatus == true)
		{
		wh_get_number_of_tld($data_tld1);
			foreach( $data_tld1 as $key => $value)
			{
				if ($key == $domaintld)
				{
				$price1 =  htmlentities ($value, ENT_QUOTES, 'UTF-8') *  htmlentities ($numberofyears, ENT_QUOTES, 'UTF-8') ;
				
				}
			}
$tld = $fulltld;
	wh_create_domain_product($fulldomainname, $domaintld, $years, $new_post_id);
		update_post_meta( $new_post_id, '_price', $price1 );
		update_post_meta( $new_post_id, '_regular_price', $price1 );
		update_post_meta( $new_post_id, '_new-or-transfer', $new_or_transfer );
		update_post_meta( $new_post_id, '_auth-code', $auth_code );
		$path2 = $_SERVER['REQUEST_URI'];
?>
<div class="whmessageboxgreen"> <?php echo esc_html ($domaincheckmessage, ENT_QUOTES, 'UTF-8' ) . ' for ' . esc_html($years) . ' &nbsp;Cost &pound;' . esc_html($price1)  ;?> </div><?php

?><div class="wh_button"><a href="<?php echo esc_html ('?add-to-cart=' . $new_post_id, ENT_QUOTES, 'UTF-8');?>">Add to basket </a></div>
	<?php

goto transfer_end;
	}
else
{
ERROR:

?><div class="whmessageboxred"> <?php echo esc_html ($domaincheckmessage, ENT_QUOTES, 'UTF-8') ;?> </div><?php
$show_reg_form = true;
//echo do_shortcode('[wh_domain_form]');
}
transfer_end:
}







if (isset($_POST['check']) && isset($_POST['domain']) && isset($_POST['tld'])) 
	{
$retrieved_nonce = $_REQUEST['_wpnonce'];
if (!wp_verify_nonce($retrieved_nonce, 'wh_domain_form' ) ) die( 'Sorry security token has expired' );
processdomain:
		$domainname = sanitize_text_field ($_POST['domain']);
		$tld = sanitize_text_field ($_POST['tld']);
		$years = sanitize_text_field ($_POST['years']);
		
			
if ($years == 'Number of Years'){$years = '1'; }
$numberofyears = substr($years, 0,1);

		
if ($tld == 'Select TLD'){$tld = '';}
 
		$error = false;
		$pos = -1;
		$pos = strpos($tld, '.');
			if ($pos === 0){
			$temp_tld = substr($tld, 1);
			$tld = $temp_tld; 
					}
				$domaintld = '.' . $tld; 
$valid_name = $domainname . $domaintld;
$tempurl = 'http://www.' . $valid_name;
$tempurl = filter_var($tempurl, FILTER_SANITIZE_URL);
if (filter_var($tempurl, FILTER_VALIDATE_URL) == true) {} 
else 	{
$domaincheckmessage = esc_html ( $fulldomainname ) . ' is not a valid URL';$error = true;
goto ERROR2;
	}
		
		$fulldomainname = $domainname . $domaintld;
		$contact_type_tld = $domaintld;
		$fullstring = $fulldomainname;
		$finddot   = '.';
		$fulllen = strlen($fulldomainname);
		$len = strpos($fullstring, $finddot);
		if ($len === false){$error = true; $domaincheckmessage = esc_attr ($fulldomainname . ' is not a valid URL');echo '<br />'; goto ERROR2;}
		$lastbit = $fulllen - $len;
		$firstbit = substr($fulldomainname, 0, -$lastbit);
		$tld = substr($fulldomainname, $len+1);$fulltld == false;
		$fulltld = substr($fulldomainname, $len);
		$fulltldlen = strlen($fulltld);
		if ($fulltldlen <3){$error = true; $domaincheckmessage = htmlentities ($fulldomainname . ' is not a valid URL');echo '<br />'; goto ERROR2;}
		$domainname = $firstbit;
		domain_checker($httpResponse,$domainname);
		
		process_domain_name($httpResponse,$domainstatus);


			$skip_years = sanitize_text_field($_POST['domainform']);
			if ($skip_years = "Y")
			{
			get_number_of_years($domainstatus);

			}
			else	{
				get_number_of_years($domainstatus);
				}
	

			wh_create_domain_product($new_post_id,$contact_type_tld);

	update_post_meta( $new_post_id, '_price', $newprice );
	update_post_meta( $new_post_id, '_regular_price', $newprice );
	update_post_meta( $new_post_id, 'domainyears', $numberofyears );
	$oneyear = date('d-m-Y', strtotime('+' . $years));
	update_post_meta( $new_post_id, 'domainexpiry', $oneyear );


	$path = get_home_url()
	?><div class="wh_button"><a href="<?php echo esc_html ($path) . '?add-to-cart=' . $new_post_id ; ?>">Add To Cart </a></div>
	
	<?php

ERROR2:
	if ($error == true)	{
	?> <div class="whmessageboxred"><?php echo esc_html ($domaincheckmessage) ?></div><?php
				}

} //end of if (isset($_POST['check'])

} // end of function

add_shortcode('check_domain_name','check_domain_name');




function wh_transfer_domain_name(){
global $httpResponse,$domainname,$tld,$domainstatus,$fulldomainname,$new_post_id,$woocommerce,$error;
wh_transfer_domain_form();
}
add_shortcode ('wh_transfer_domain_name','wh_transfer_domain_name');



function domain_checker($httpResponse,$domainname)
{
	include (WH_PATH."wh_globals.php" );
	global $httpResponse,$url,$data,$tld,$domainname,$method,$str,$data_tld1;
	$url1 = 'https://' . $rc_url . 'httpapi.com/api/domains/available.json?';
	$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&domain-name=' . $domainname . '&tlds=' . $tld ;
$url = $url1 . $str;
    $data = "";
    $data = CallDomainAPI('GET', $url, $data);
    $result = json_decode($data, TRUE);
	$httpResponse = $result;
	return $httpResponse;
} // end of function
function CallDomainAPI($method, $url, $data = false) 
{
	$curl = curl_init();
	switch ($method) 
	{
		case "POST":
		curl_setopt($curl, CURLOPT_POST, 1);
			if ($data)
			curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
			break;
		case "PUT":
		curl_setopt($curl, CURLOPT_PUT, 1);
		break;
		default:
			if ($data)
			$url = sprintf("%s?%s", $url, http_build_query($data));
	}
    curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    curl_setopt($curl, CURLOPT_USERPWD, "username:password");
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    return curl_exec($curl);
}
function process_domain_name($httpResponse,$domainstatus)
{
global $httpResponse,$domainstatus,$wpdb,$domainname,$tld,$domainstatus,$fulldomainname,$new_or_transfer,
$transferstatus,$data_tld1,$domaincheckmessage,$transfer_error;
		if ($new_or_transfer == 'transfer2')	{
		$tld = $domaintld;
		$pos = -1;
		$pos = strpos($tld, '.');
			if ($pos === 0) {
			$temp_tld = substr($tld, 1);
			$tld = $temp_tld; 
					}
							}
	$fulldomainname = $domainname . '.' . $tld ;
	if ($httpResponse[$fulldomainname]["status"] == "unknown") 
	{
	$domainstatus = false;$transferstatus = false;
	$domaincheckmessage = 'Sorry Unknown error occurred, please try again later';
	}
	if ($httpResponse[$fulldomainname]["status"] == "regthroughus" || ($httpResponse[$fulldomainname]["status"] == "regthroughothers"))
  {	
	$domainstatus = false;
		if ($new_or_transfer == 'transfer')	{
		$transferstatus = true;$domainstatus = true;
		$domaincheckmessage = 'Congratulations ' . $fulldomainname . ' is available to transfer';
		return $transferstatus;
							}
else
	{
	$domaincheckmessage = 'Sorry ' . $fulldomainname . ' is already taken';
	}
  } // end of if ($httpResponse[$fulldomainname]["status"] == "regthroughus"
	$product_id = false;
	$product_id = $wpdb->get_var( "SELECT ID FROM $wpdb->posts WHERE post_title = '" . $fulldomainname . "'" );
		if ($product_id)
		{
		$domainreg = get_post_meta( $product_id, 'domain-registered',true);
		if ($domainreg == 'yes'){$domainstatus = false; $domaincheckmessage = 'Sorry ' . $fulldomainname . ' Is Not Available ';}
		} // end of if ($product_id)
if ($httpResponse[$fulldomainname]["status"] == "available") 
   {
	$domainstatus = true;
        if (isset($httpResponse[$fulldomainname]["ror"]) && ($httpResponse[$fulldomainname]["ror"] <> '')) 
  	 	{
		$ror = $httpResponse[$fulldomainname]["ror"];
			if ($new_or_transfer == 'transfer')
			{
			$domaincheckmessage = 'Sorry ' . $fulldomainname . ' Is not available to transfer but Is Available to register but someone else may own the corresponding third-level name eg ' . $ror . ' this domain will be reserved for this registrant.';
			return $transferstatus;
			}
			else
			{
			$domaincheckmessage = 'Congratulations ' . $fulldomainname . ' Is Available but someone else may own the corresponding third-level name eg ' . $ror . '<br /> this domain will be reserved for this registrant.';
			}
    		} // end of if (isset($httpResponse[$fulldomainname]["ror"]) && 
else
	{
	if ($new_or_transfer == 'transfer')	{
		$domaincheckmessage = 'Sorry ' . $fulldomainname . ' Is not available to transfer but Is Available to register ';$transfer_error = true;
		return $transferstatus;
				  	   	}
			else
			{
			$domaincheckmessage = 'Congratulations ' . $fulldomainname . ' Is Available ';
			}
	}
 } // end of if ($httpResponse[$fulldomainname]["status"] == "available")
		if (isset($domaincheckmessage))
		{
								
	if ($domainstatus == true){ ?> <div class="whmessageboxgreen"> <?php echo esc_html ($domaincheckmessage);?> </div> <?php }	
else
	{ ?> <div class="whmessageboxred"> <?php echo esc_html ($domaincheckmessage);?> </div> <?php }	
		} // end of if (isset($domaincheckmessage)
if ($new_or_transfer == 'transfer'){return $domaincheckmessage;}
else{return $domainstatus;}
  
} // end of the function




function wh_domain_form()
{
 ob_start();
	$domain_page = get_option( 'wh_domainspage', true );

$siteurl = get_home_url();

	?>
	<div id="web_domain_form">
	<form action="<?php echo esc_attr ($siteurl) . esc_attr ($domain_page);?>" method="post">
<?php wp_nonce_field('wh_domain_form'); ?>
<table class="web_domain_form_table">
<thead>

<tr><th>Search Domain Name</th>

		<th><input name="domain" type="text" pattern="[a-z0-9 -]+" value=""/></th>

					<th>
	
					<select name="tld">
					<?php
					$number_of_tld = get_option( 'tlds');
					$count = 0;
					?><option>Select TLD</option><?php
					do
					{
					$count++;
					$s = get_option( 'wh_tld' . $count);
					?><option><?php echo esc_html($s);?></option><?php
					} while ($count < $number_of_tld);
					?>
					</select>
					
					</th>

</tr><tr><th>
		<div class = "numberofyears">
		<select name="years"><option>Number of Years</option>
		<option>1 Year</option>
		<option>2 Years</option>
		<option>3 Years</option>
		<option>4 Years</option>
		<option>5 Years</option>
		</select>
		</div>


</th><th></th><th>
	
	<input name="check" type="submit" value="Check" />
	
</th></tr>

</table>

	</form>
	
	</div>
	<?php
$output_string=ob_get_contents();
ob_end_clean();

return $output_string;
}
add_shortcode('wh_domain_form','wh_domain_form');



function get_number_of_years($domainstatus)
{
global $tld,$data_tld1,$fulldomainname,$domainstatus,$domaintld,$years,$newprice,$numberofyears;



if (isset($domainstatus) && ($domainstatus == true))
	{
		if (isset($transferstatus) && ($transferstatus == true))
		{
		$new_or_transfer = 'transfer';
		}
		else {$new_or_transfer = 'new';}

			$product_id = "";
			$product_id = $new_post_id;
			$numberofyears = substr($years, 0,1);
			$number_of_tld = get_option( 'tlds');



	$count = 0;
	do
	   {
	   $count++;
		$s = get_option( 'wh_tld' . $count);
		$data_tld1[$s] = get_option( 'wh_tld' . $count . 'price');
		if ($s == $domaintld){$we_sell_it = true;$price = $data_tld1[$s];}

		} while ($count < $number_of_tld);


		$newprice = ($price * $numberofyears);

if ($we_sell_it == false) {echo 'domain is available but we are currently not selling ' . esc_html ($domaintld);}





	} // end of if (isset($domainstatus)


} // end of function


function wh_create_domain_product($new_post_id){
	include (WH_PATH."wh_globals.php" );
	global $fulldomainname,$wpdb,$new_post_id;
	$domain_id = false;
	$domain_id = $wpdb->get_var( "SELECT ID FROM $wpdb->posts WHERE post_title = '" . $fulldomainname . "'" );
		if ($domain_id == false){
		$user_ID = '';
		$new_post = array(
		'post_id' => '',
		'post_title' => $fulldomainname,
		'post_content' => 'Domain Name',
		'post_status' => 'publish',
		'post_date' => date('Y-m-d H:i:s'),
		'post_author' => $user_ID,
		'post_type' => 'product',
		'post_category' => array(0)
		);
	$post_id = wp_insert_post($new_post);
	$new_post_id = $post_id;
	$imgurl = site_url();
	add_post_meta( $new_post_id, 'nameserver01', $wh_nameserver01 );
	add_post_meta( $new_post_id, 'nameserver02', $wh_nameserver02 );
	add_post_meta( $new_post_id, 'nameserver03', $wh_nameserver03 );
	add_post_meta( $new_post_id, 'nameserver04', $wh_nameserver04 );
	add_post_meta( $new_post_id, 'entityid', '' );
	add_post_meta( $new_post_id, 'domaintype', '1' );
	add_post_meta( $new_post_id, 'customer-id', '' );
	add_post_meta( $new_post_id, 'domain-registered', 'no' );
	add_post_meta( $new_post_id, 'domain-registered-date', '' );
	add_post_meta( $new_post_id, 'domainyears', $years );
	add_post_meta( $new_post_id, 'package', 'domain' );
	add_post_meta( $new_post_id, 'domaintld', '0' );
	add_post_meta( $new_post_id, 'new-or-transfer', $new_or_transfer);
	add_post_meta( $new_post_id, 'auth-code', $auth_code);
if ($tld == '.co.uk'){
update_post_meta( $new_post_id, 'domaintld', '1' );
}
if ($tld == '.uk'){
update_post_meta( $new_post_id, 'domaintld', '1' );
}
if ($tld == '.me.uk'){
update_post_meta( $new_post_id, 'domaintld', '1' );
}
if ($tld == '.org.uk'){
update_post_meta( $new_post_id, 'domaintld', '1' );
}
if ($tld == '.co'){
update_post_meta( $new_post_id, 'domaintld', '2' );
}
	add_post_meta( $new_post_id, 'domainexpiry', '' );
	wp_set_object_terms($new_post_id, 'simple', 'product_type');
	wp_set_object_terms( $new_post_id, 'Domains', 'product_cat' );
     update_post_meta( $new_post_id, '_visibility', 'Hidden' );
     update_post_meta( $new_post_id, '_stock_status', 'instock');
     update_post_meta( $new_post_id, 'total_sales', '0');
     update_post_meta( $new_post_id, '_downloadable', 'no');
     update_post_meta( $new_post_id, '_virtual', 'yes');
     update_post_meta( $new_post_id, '_regular_price', $price );
     update_post_meta( $new_post_id, '_sale_price', "" );
     update_post_meta( $new_post_id, '_purchase_note', $fulldomainname );
     update_post_meta( $new_post_id, '_featured', "no" );
     update_post_meta( $new_post_id, '_weight', "" );
     update_post_meta( $new_post_id, '_length', "" );
     update_post_meta( $new_post_id, '_width', "" );
     update_post_meta( $new_post_id, '_height', "" );
     update_post_meta( $new_post_id, '_sku', "domains");
     update_post_meta( $new_post_id, '_product_attributes', array());
     update_post_meta( $new_post_id, '_sale_price_dates_from', "" );
     update_post_meta( $new_post_id, '_sale_price_dates_to', "" );
     update_post_meta( $new_post_id, '_price', $price );
     update_post_meta( $new_post_id, '_sold_individually', "yes" );
     update_post_meta( $new_post_id, '_manage_stock', "no" );
     update_post_meta( $new_post_id, '_backorders', "no" );
     update_post_meta( $new_post_id, '_stock', "1" );
     update_post_meta( $new_post_id, '_type' , "domain");
} // end of if ($domain_id == false)
	else {$new_post_id = $domain_id;}
	return $new_post_id;
}
add_action('wh_create_domain_product','wh_create_domain_product');
function wh_get_number_of_tld($data_tld1)
{
	global $data_tld1;
	$number_of_tld = get_option( 'tlds');
	$count = '0';
	do
	{
	$count++;
	$s = get_option( 'wh_tld' . $count) ;
	$data_tld1[$s] = get_option( 'wh_tld' . $count . 'price');
	} while ($count < $number_of_tld );
	return $data_tld1;
}
add_action('wh_get_number_of_tld','wh_get_number_of_tld');
function random_password( $length) {
$count = 0;
tryagain:
	$findspecialchar = "/\#~()";$len = false;
	$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789#~!()+";
	$randpassword = substr( str_shuffle( $chars ), 0, $length );
		if (preg_match('/[()\[\]#~!-+]+/',$randpassword )) {
		
			} else {
				
				$count++; 
					if ($count > 100){return $randpassword;} 
				goto tryagain;
				}
    return $randpassword;
}
function wh_check_domain_is_reg($order_id)
{
	global $woocommerce;
	global $order_id;
	global $a;
	global $product_name;
	global $httpResponse;
$response = false;
	wh_get_order_details($a, $order_id);
	$order = new WC_Order($a);
	
		$items = $order->get_items();
		foreach ( $items as $item ) 
	{
		$producttype = false;
		$product_name = $item['name'];
		$product_id = $item['product_id'];
		$producttype = get_post_meta( $product_id, 'package',true);
		$ordernumber = get_post_meta( $product_id, 'entityid',true);
	if (isset($producttype) && ($producttype == "domain"))
		{ 
		$domainreg = get_post_meta( $product_id, 'domain-registered',true);
		if (isset($domainreg) && ($domainreg == "no"))
		{
	wh_check_domains_order($product_name, $httpResponse);
if (ctype_digit($httpResponse)) 
	
{
	$response = true;
	update_post_meta( $product_id, 'domain-registered', "yes");
	update_post_meta( $product_id, 'domain-registered-date', date("d/m/Y"));
	$years = get_post_meta( $product_id, 'domainyears',true);	
	$expirydate = date('d-m-Y', strtotime('+' . $years));
	update_post_meta( $product_id, 'domainexpiry', $expirydate );
	get_post_meta( $product_id , 'entityid',true);
	update_post_meta( $order->id , $product_id, $ordernumber );
}
		}
		}
	}
return $response;
}
add_action('wh_check_domain_is_reg','wh_check_domain_is_reg');
function wh_subscriptions()
{
global $woocommerce, $a, $order_id, $newinvoicedata, $order,$numberofdays,$username,$domain,
$product_name,$wh_newinvoice_email,$ordered_products,$domain_renew,$data_tld1,$wh_orders_days;
	$args = array(
	'blog_id'      => $GLOBALS['blog_id'],
	'role'         => 'Customer',
	 ); 
	$filters = array(
	    'post_status' => 'publish',
	    'post_type' => 'shop_order',
	    'posts_per_page' => 200,
	    'paged' => 1,
	    'orderby' => 'modified',
	    'order' => 'ASC'
	);
$today = date('d-m-Y');
// when using cron manager it sometimes fires twice next few lines stop this from happening
$testdate = get_option('wh_subscription_run',true);
	if (isset($testdate) && ($testdate !== $today)){
	 update_option( 'wh_subscription_run', $today, '', 'yes' ); 
	 
	 
	 	
	 
	 
	$s = '0';
	$sss = '0';
	$productcount = '0';
	$domain_renew = '';
	$product_list = array();
	$blogusers = get_users( 'role=Customer' );
		foreach ( $blogusers as $user ) 
		{
		$current_customer = ( $user->ID );
		$newinvoice = '';
	$loop = new WP_Query($filters);
	while ($loop->have_posts()) 
	{
	$loop->the_post();
$order_processed = false;
	$order = new WC_Order($loop->post->ID);
	$orderdate = get_post_meta($order->id, '_invoice_date',true);
	$order_processed = get_post_meta($order->id, 'wh_order_processed',true);
	$wh_orders_days = get_option( 'wh_order_days', true );
if($order_processed == false){
	if($orderdate == '')	{
	$orderdate = $order->order_date;
			}
	$ordernumber = $order->id;
	$invoicedate = substr($orderdate,0,-9);
	$user_id = $order->user_id;
if (isset($current_customer) && ($current_customer == $user_id))
{
  $ss = '0';
  $newinvoicedata = array();
  $billing_address = array();
  $billing_address['first_name'] = get_post_meta($order->id,'_billing_first_name',true);
  $billing_address['last_name'] = get_post_meta($order->id,'_billing_last_name',true);
  $billing_address['company'] = get_post_meta($order->id,'_billing_company',true);
  $billing_address['email'] = get_post_meta($order->id,'_billing_email',true);
  $billing_address['phone'] = get_post_meta($order->id,'_billing_phone',true);
  $billing_address['address_1'] = get_post_meta($order->id,'_billing_address_1',true);
  $billing_address['address_2'] = get_post_meta($order->id,'_billing_address_2',true);
  $billing_address['city'] = get_post_meta($order->id,'_billing_city',true);
  $billing_address['state'] = get_post_meta($order->id,'_billing_state',true);
  $billing_address['postcode'] = get_post_meta($order->id,'_billing_postcode',true);
  $billing_address['country'] = get_post_meta($order->id,'_billing_country',true);
  $billing_address['paymethod'] = get_post_meta($order->id,'_payment_method',true);
  $shipping_address = array();
  $shipping_address['first_name'] = get_post_meta($order->id,'_shipping_first_name',true);
  $shipping_address['last_name'] = get_post_meta($order->id,'_shipping_last_name',true);
  $shipping_address['company'] = get_post_meta($order->id,'_shipping_company',true);
  $shipping_address['email'] = get_post_meta($order->id,'_shipping_email',true);
  $shipping_address['phone'] = get_post_meta($order->id,'_shipping_phone',true);
  $shipping_address['address_1'] = get_post_meta($order->id,'_shipping_address_1',true);
  $shipping_address['address_2'] = get_post_meta($order->id,'_shipping_address_2',true);
  $shipping_address['city'] = get_post_meta($order->id,'_shipping_city',true);
  $shipping_address['state'] = get_post_meta($order->id,'_shipping_state',true);
  $shipping_address['postcode'] = get_post_meta($order->id,'_shipping_postcode',true);
  $shipping_address['country'] = get_post_meta($order->id,'_shipping_country',true);
	$s = 0;
	$emailed = false;
	foreach ($order->get_items() as $key => $lineItem) 
	{
	$charge = ''; $domain_renew = '';$check_renew_date = '';
        $productname = $lineItem['name'];
        $productid = $lineItem['product_id'];
	$cost = $lineItem['cost'];
	$qty = $lineItem['qty'];
	$item_meta = $lineItem['item_meta'];
	$checkcostyear = false;
	$checkcostmonth = false;
	$cost = strtolower($cost);
	$checkcostyear = strpos($cost, 'per year');
	$checkcostmonth = strpos($cost, 'per month');
	$is_product_domain = get_post_meta($productid,'package',true);
if(isset($is_product_domain) && ($is_product_domain == 'domain') || ($is_product_domain == 'domain-renew'))
		{
		$checkdomain == true;
	$d = new DateTime( $orderdate );
	$e = new DateTime( $orderdate );
	
// ****************** Need to get number of years here for domains *****************
$check_number_of_years = get_post_meta( $productid, 'domainyears', true );
		$d->modify( '+' . $check_number_of_years . ' years'); $tempdate = $d;
		$d->modify( '-' . $wh_orders_days .' days');
		$invoicedate = $d->format( 'd-m-Y' );
		$charge = ' yearly ';
		$check_renew_date = get_post_meta( $productid, 'domainexpiry', true );
		
					
	
	
		
		
		
		
		if($invoicedate <= $check_renew_date)
		{
			
			
		
			
			
			
				
		if($is_product_domain == 'domain-renew'){$domain_renew = 'Domain Renewal: ';}
		
		$result = get_post_meta( $productid, '_price', true );
	
		$fullstring = $productname;
		$finddot   = '.';
		$fulllen = strlen($productname);
		$len = strpos($fullstring, $finddot);
		$lastbit = $fulllen - $len;
		$firstbit = substr($productname, 0, -$lastbit);
		$tld = substr($productname, $len+1);
		$fulltld = substr($productname, $len);
$years = strtolower($check_number_of_years);
$years = str_replace(' years', '', $years);
wh_get_number_of_tld($data_tld1);
			foreach( $data_tld1 as $key => $value)
			{
				if ($key == $fulltld)
				{
				$price1 = $value ;
				}
			}
$updated_price = $price1 * $years;
			
		update_post_meta( $productid, 'package', 'domain-renew' );
		
		// added on 03/11/2016 *********************************************
		
		
		$d = $tempdate;
		$d->modify( '+' . $check_number_of_years . ' years');
		$d->modify( '+' . $wh_orders_days .' days');
		$e->modify( '+' . $check_number_of_years . ' years');
		update_post_meta( $productid, 'domainexpiry', $d->format( 'd-m-Y' ) );
		update_post_meta( $productid, 'domain reordered date', $e->format( 'd-m-Y' ));
		// ***********************************************************************
	


		update_post_meta( $productid, '_price', $updated_price );
		update_post_meta( $productid, '_regular_price', $updated_price );
		$item_meta['_line_subtotal'][0] = $updated_price;
		$item_meta['_line_total'][0] = $updated_price;
		}
}

		



		if(isset($checkcostyear) && ($checkcostyear == true))
		
	  {
	
	if (preg_match('/(?<=\)\d+(\.\d+)?\b/', $cost, $regs)) 
	{
	    $result = $regs[0];
	}
	$d = new DateTime( $orderdate );
	$d->modify( '+ 1 year' );
	$d->modify( '-' . $wh_orders_days . ' days' );
	$invoicedate = $d->format( 'd-m-Y' );
	$charge = ' yearly ';
	
	
	
	
	
	
	}
		if(isset($checkcostmonth) && ($checkcostmonth == true))
 		{
			if (preg_match('/(?<=\)\d+(\.\d+)?\b/', $cost, $regs)) 
 			 {
			    $result = $regs[0];
			 }
		$d = new DateTime( $orderdate );
		$d->modify( '+ 1 month' );
	//	$d->modify( '- 7 days' );
		$d->modify( '-' . $wh_orders_days . ' days' );
		$invoicedate = $d->format( 'd-m-Y' );
		$charge = ' Monthly ';
		}
		if (isset($result) && ($today == $invoicedate))
		{
		$paid = $order->post_status;
		if (isset($paid) && ($paid <> 'wc-completed'))
		{ $order_status = 'unpaid';
		$is_product_hosting = get_post_meta($productid,'package',true);
			if ($is_product_hosting == 'hosting'){wh_suspend_account();}
	if ($emailed == false){wh_email_unpaid_invoice($productid);$emailed = true;}
		}
		$newinvoicedata['order_id'] = $ordernumber;
		$newinvoicedata['user_id'] = $user_id;
		$newinvoicedata['invoicedate'] = $invoicedate;
		$newinvoicedata['paymentmethod'] = $billing_address['paymethod'];
		$newinvoicedata['email_address'] = $billing_address['email'];
		$newinvoicedata['first_name'] = $billing_address['first_name'];
		$newinvoicedata['last_name'] = $billing_address['last_name'];
		$newinvoicedata['address01'] = $billing_address['address_1'];
if ($billing_address['address_2'] <> ''){
		$newinvoicedata['address02'] = $billing_address['address_2'];}
if ($billing_address['address_3'] <> ''){
		$newinvoicedata['address03'] = $billing_address['address_3'];}
		$newinvoicedata['city'] = $billing_address['city'];
		$newinvoicedata['state'] = $billing_address['state'];
		$newinvoicedata['postcode'] = $billing_address['postcode'];
		$newinvoicedata['product_id'.$s] = $productid;
		$newinvoicedata['product_name'.$s] = $productname;
		$newinvoicedata['cost'.$s] = $result;
		$newinvoicedata['qty'.$s] = $qty;
		$newinvoicedata['item_meta'.$s] = $item_meta;
		$newinvoicedata['item_meta_cost'.$s] = $item_meta['_line_subtotal'][0];
		$variation_cost = $item_meta['cost'];
		$s++;
	$product_list [$productcount] = $productid ;$productcount++;
//} // end of if($check_renew_date <= $invoicedate)
}// end of if ($today == $invoicedate)
} // end of foreach ($order->get_items() as $key => $lineItem)
} // end of if ($current_customer == $user_id)
		if (isset($newinvoicedata) && ($newinvoicedata <> '')){
		$wh_newinvoice_email = true;
		$data = count($newinvoicedata);
			if ($data > '0'){
				if ($ss == '0'){
				// make sure this order does not get processed again 
				
				update_post_meta($order->id, 'wh_order_processed','1');
				$order = wc_create_order();
				$order->set_address( $billing_address, 'billing' );
				$order->set_address( $shipping_address, 'shipping' );
				$order->update_status('wc-pending');
				$order->set_payment_method($this);
				$ss = '1';$cc = '0';
					}
			foreach ($newinvoicedata as $key => $value)
			{
			if ($key == 'product_id' . $cc)
			{
			$productid = $value;
			$variation = $newinvoicedata['item_meta'. $cc]['_variation_id'];$cc++;
			$new_variation = $variation['0'];
			
	if ($new_variation >0){
	$temp = $order->add_product( get_product( $new_variation ), $qty,$variation );
	$ordered_products .=  $new_variation;
	woocommerce_add_order_item_meta($temp, 'cost', $variation_cost);
			
			}
	else
	{
	$temp = $order->add_product( get_product( $productid ), $qty,$variation);
	}
			}
			
			}
			if ($ss == '1'){
			$order->calculate_totals();
			update_post_meta($order->id, '_customer_user', $user_id);
			update_post_meta($order->id, '_created_via', 'checkout');
			update_post_meta($order->id, '_invoice_type', '1');
update_post_meta($order->id, '_invoice_date',$today ); // ** changed from $orderdate 02/06
			update_post_meta($order->id, 'wh_order_processed','0');
			$ss = '2';
			$wh_newinvoice_email = true;
	wh_newinvoice_customer_email();
}
	
} //end of if ($newinvoicedata <> '')
	$newinvoicedata = '';
}
} // end of if($order_processed == false)
} // end of while ($loop->have_posts()) {
} // end of foreach ( $blogusers as $user )
} // end of if ($testdate <> $today)
else
{
$cronerror = true;
}

}
add_action('wh_subscriptions','wh_subscriptions');


function wh_suspend_account()
{
global $woocommerce, $order;
	$first_name = get_post_meta($order->id,'_billing_first_name',true);
	$last_name = get_post_meta($order->id,'_billing_last_name',true);
		$youremail = get_option( 'admin_email', $default );
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		$headers .= 'From:' . $youremail . "\r\n";
		$subject="Suspend Account" ;
		$mail_to = get_option( 'admin_email', $default );
$body_message2 = 'Please note Customer ' . $first_name . ' ' . $last_name . ' ID ' . $order->user_id . 'has not paid their last invoice<br />';
$body_message2 .= 'Order No ' . $order->id . '<br /> Please suspend their account';
mail($mail_to, $subject, $body_message2, $headers); 
}
add_action('wh_suspend_account','wh_suspend_account');






function wh_email_unpaid_invoice($productid)
{
global $woocommerce, $order,$overdueinvoices,$productid;
array_push($overdueinvoices, $order->id);
$overdueinvoices[$order->id] = $productid;
update_option('wh_overdueinvoices',$overdueinvoices);
	$first_name = get_post_meta($order->id,'_billing_first_name',true);
	$last_name = get_post_meta($order->id,'_billing_last_name',true);
		$youremail = get_option( 'admin_email', $default );
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		$headers .= 'From:' . $youremail . "\r\n";
		$subject="Overdue Invoice" ;
		$mail_to = get_option( 'admin_email', $default );
$body_message = 'Please note Customer ' . $first_name . ' ' . $last_name . ' ID ' . $order->user_id . ' has an overdue invoice<br />';
$body_message .= 'Order No ' . $order->id . '<br /> Please contact customer';
mail($mail_to, $subject, $body_message, $headers); 


}
add_action('wh_email_unpaid_invoice','wh_email_unpaid_invoice');
function wh_newinvoice_customer_email()
{
global $woocommerce, $a, $order_id, $newinvoicedata,$numberofdays,$username,$domain,$product_name,
$wh_newinvoice_email,$order,$today,$duedate,$address_message,$ordered_products, $filename, $path,
$file, $table_message, $table_message2, $table_message4, $footer_message,$domain_renew;
		$cc = '0';
		$d = new DateTime( $newinvoicedata['invoicedate'] );
		$d->modify( '+ 1 week' );
		$duedate = $d->format( 'd-m-Y' );
		$today = date("d-m-Y"); 
			foreach ($newinvoicedata as $key => $value)
			{
			if ($key == 'product_name' . $cc)
			{
			$productname .= $value . '<br />';
			$productqty .= $newinvoicedata['qty' . $cc] . '<br />';
			$productcost .= '&pound;' . $newinvoicedata['item_meta_cost' . $cc] . '<br />';
			$total = $total + $newinvoicedata['item_meta_cost' . $cc] ;
			
			$cc++;
			}
			
			}
		$filename = 'Invoice-' . $order->id . '.pdf';
		
		// changed uploads folder from plugin folder to wordpress uploads folder
		
	//	$path = (dirname(__file__).'/temp/');
		
		$uploads_url = wp_upload_dir() ;
		$upload_dir = $uploads_url['basedir'];
		$upload_dir2 = $upload_dir . '/web-hosting-uploads/';
				if (! is_dir($upload_dir2)) {
				wp_mkdir_p( $upload_dir2);
				}
		$path = $upload_dir2;
		
		
		
		
		
		$file = $path.$filename;

$pdf_image = plugins_url('/images/logo.png' , __FILE__ ); // changed from content_ to plugins_ 02-11-16
$myaccount_url = get_permalink( get_option('woocommerce_myaccount_page_id'));
$body_message ='<body leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" offset="0">
<div id="wrapper" dir="ltr" style="background-color: #000; margin: 0; padding: 70px 0 70px 0; -webkit-text-size-adjust: none !important; width: 100%;"><table border="0" cellpadding="0" cellspacing="0" height="100%" width="100%"><tr><td align="center" valign="top">';
$body_message .= '<img src="' . $pdf_image . '">';
$body_message .= '<h1 style="width: 600px; height: auto; background:#49657d; color:#fff; margin-left:auto;margin-right:auto;text-align:left; line-height:3.6em;padding-left: 48px;font-family: "Helvetica Neue", Helvetica, Roboto, Arial, sans-serif;font-size:20px;">';
$body_message .= 'Invoice</h1><p style="color:#00ff00;width: 500px; height: auto;margin-left:auto;margin-right:auto;text-align:left;font-size:14px;"><br />Dear <b>' . $newinvoicedata['first_name'] . ' ' . $newinvoicedata['last_name'] . '</b> This is a notice that an invoice has been generated on ' . $today . '.<br /> 
<br />
Your payment method is: ' . $newinvoicedata['paymentmethod'] . '<br /> 
<br />
Invoice No ' . $order->id . '<br /></p>';
$address_message = '<p style="color:#000;">Invoiced To:<br />' . $newinvoicedata['first_name'] . ' ' . $newinvoicedata['last_name'] . '<br /> ' . $newinvoicedata['address01'] . '<br />';
	if ($newinvoicedata['address02']<>'')
	{ 
	$address_message .= $newinvoicedata['address02'] . '<br />';
	}
	if ($newinvoicedata['address03']<>'')
	{ 
	$address_message .= $newinvoicedata['address03'] . '<br />';
	}
$address_message .= $newinvoicedata['city'] . '<br />' . $newinvoicedata['state'] . '<br />' . $newinvoicedata['postcode'] . '<br /></p>';
$table_message1 ='<p style="color:#fff;width: 500px; height: auto;margin-left:auto;margin-right:auto;">';
$table_message2 ='<p style="color:#000;width: 500px; height: auto;margin-left:auto;margin-right:auto;">';
$table_message3 = '<table style="border-collapse: collapse;width:500px;color:#fff;">';
$table_message4 = '<table style="border-collapse: collapse;width:500px;color:#000;">';
$table_message ='<tr><th style="background-color: #557da1;border: 1px solid white;text-align: center;">Item</th><th style="background-color: #557da1;	border: 1px solid white;text-align: center;">Qty</th><th style="background-color: #557da1;border: 1px solid white;text-align: center;">Cost</th></tr><tr><td style="border: 1px solid white;text-align: center;">' . $domain_renew . ' ' . $productname . '</td><td style="text-align: center;border: 1px solid white;">' . $productqty . '</td><td style="border: 1px solid white;text-align: center;">' . $productcost . '</td></tr>
</table>
<br /><br /><b>Amount Due: ' . $total . ' GBP</b><br />
<br />If paying via Paypal Please login to your account area to make payment. <a href="' . $myaccount_url . '">Login</a><br />';
$body_message .= $table_message1 . $table_message3 . $table_message;


$opt_val_companyname = get_option( 'wh_companyname' );
$opt_val_companyaddress01 = get_option( 'wh_companyaddress01' );
$opt_val_companyaddress02 = get_option( 'wh_companyaddress02' );
$opt_val_companycity = get_option( 'wh_companycity' );
$opt_val_companystate = get_option( 'wh_companystate' );
$opt_val_companypostcode = get_option( 'wh_companypostcode' );
$opt_val_companyphone = get_option( 'wh_companyphone' );

$opt_val_companyemail = get_option( 'admin_email', $default );
$opt_val_companyweb = get_home_url();



$footer_message = '<br /><br />' . $opt_val_companyname;
$footer_message .= '<br />' . $opt_val_companyaddress01;
$footer_message .= '<br />' . $opt_val_companyaddress02;
$footer_message .= '<br />' . $opt_val_companycity;
$footer_message .= '<br />' . $opt_val_companystate;
$footer_message .= '<br />' . $opt_val_companypostcode;
$footer_message .= '<br /><br />' . $opt_val_companyphone;
$footer_message .= '<br />' . $opt_val_companyemail;
$footer_message .= '<br /><br />' . $opt_val_companyweb;



wh_pdf_invoice();
	$mail = new PHPMailer;
	$mail->From = get_option( 'admin_email', $default );
	$mail->FromName = get_option( 'blogname', $default );
	$mail->addAddress($newinvoicedata['email_address'], "");
	//Provide file path and name of the attachments
	$mail->addAttachment($file);        
	$mail->isHTML(true);
	$mail->Subject = "Customer Invoice";
	$mail->Body = $body_message;
	$mail->AltBody = "This is the plain text version of the email content";
	$mail->send();
}
add_action('wh_email','wh_newinvoice_customer_email');
function wh_pdf_invoice(){
global $filename, $file, $newinvoicedata, $table_message, $table_message2, $table_message4, $footer_message;
global $order,$today,$duedate,$address_message;
	$pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
   	 // Set various pdf options
	$pdf->SetAuthor('David Gennoe');
	$pdf->SetTitle('Customer Invoice');
    	// etc.
    	// Now output the html
$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, PDF_HEADER_STRING);
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
$pdf->SetFont('dejavusans', '', 10);
$pdf->AddPage();
        
$pdf->Ln(20);
// add some content
$html = '<h1>Invoice</h1><br /><br /><h3>Invoice No ' . $order->id . '</h3><br />Invoice Date: ' . $today . '<br /><br />
Due Date: ' . $duedate . '<br />
Your payment method is: ' . $newinvoicedata['paymentmethod'] . '<br />
<br />' . $address_message . '<br />';
$temp = $html;
$pdf->writeHTML($html, true, 0);
$pdf->SetFont('dejavusans', '', 10);
$temp .= $table_message2 . $table_message4. $table_message;
$html = $table_message2 . $table_message4 . $table_message;
$pdf->writeHTML($html, true, 0);
$pdf->SetFont('dejavusans', '', 9);
$temp .= $footer_message;
$html = $footer_message;
$pdf->writeHTML($html, true, 0);
$pdf->Output($file, 'F');
update_post_meta( $order->id, $filename, $temp );
}
add_action('wh_pdf_invoice','wh_pdf_invoice');
function WHM_create_account()
{
	global $whm_hash_key;
	global $whm_username;
	global $whm_ip;
	global $whm_servername;
	global $wpdb;
	global $api_user_id;
	global $api_key;
	global $package;
	global $fulldomainname;
	global $user_id;
	global $product_id;
	global $order;
	global $woocommerce;
	global $newdomain;
	global $randpassword;
	global $accountemail;
	global $username;
	global $count;
	global $whmcount;
	global $whmcount2;
	global $whmcount3;
	global $list;
	global $checkusernames;
	global $checkusernames2, $data, $key, $length;
	define("XMLAPI_HOST", $whm_ip);
	
	
	$customer_id = $user_id ;
	$str = false;
	$pos = false;
	$packageactive = false;
	$whmcount3 = 3;
	$username = str_replace(".","",$newdomain);
	$username = substr($username, 0, 8);
	$accountpassword = '';
	
			$random = random_password( $length = 12);
			$data = $random;$key  = 'qJB0rGtIn5UB1xG03efyCp';
			$encrypted = encryptIt( $data, $key );
	$whm = array("username" => $username, "password" => $encrypted, "key" => $key);
		update_user_meta($user_id,'_whm_account' . $username, $whm );
				
				$accountpassword = $data;
	$post = get_post($product_id);
	$slug = $post->post_name;
	$product_name = get_the_title( $product_id );
	$package = $whm_username . '_' . $slug;
	$root_hash = $whm_hash_key;
//	$ip = getenv('REMOTE_HOST');
	$ip = $whm_ip;

	$xmlapi = new xmlapi($ip);
	$xmlapi->hash_auth($whm_username,$root_hash);
	$xmlapi->return_xml(1);
	$xmlapi->set_debug(1);
	
CREATE:
	$checkusernames = false;
	$checkusernames2 = false;
	$exit = 0;
	$list = $xmlapi->listaccts($searchtype = null,$search = null,$searchmethod = null,$want = null);
	$checkusernames = strpos($list, $username);
	$checkusernames2 = $list;

		if (isset($checkusernames) && ($checkusernames == true))
		{
		$count++;
		if ($count > 8){goto EXITA;}
		wh_change_username($username);
		goto CREATE;
		}
if ($checkusernames == false)
{
				
	$ip = getenv('REMOTE_HOST');
//	$ip = $whm_ip;
	$xmlapi = new xmlapi($ip);
	$xmlapi->hash_auth($whm_username,$root_hash);
	$xmlapi->return_xml(1);
	$xmlapi->set_debug(1);
	$acct = array( username => $username, password => $accountpassword, contactemail => $accountemail, domain => $newdomain, plan => $package);
	$result = $xmlapi->createacct($acct);
	$checkresult = strpos($result, $username);
	$createresult = false;	   
	$createresult = strpos($result, 'This system already has an account named');
				
if (isset($createresult) && ($createresult == true))
{
$count++;
if ($count > 5){goto EXITA;}
wh_change_username($username);
goto CREATE;
}
 if ($checkresult){update_user_meta($user_id, 'WHM_' . $newdomain, $username );
		}
} // end of if ($checkusernames == false)
EXITA:
	
} // end of WHM_create_account
function wh_change_username($username)
{
global $username,$whmcount,$whmcount2,$whmcount3,$count,$list,$checkusernames,$checkusernames2;
	$extra_letters = 'abcdefghijklmnopqursuvwxyz';
CREATE2:
	$whmcount++;$exit++;
	$username = substr($username, 0, 7);$username = $username . $whmcount;
		if ($whmcount > 9)
		{
		$whmcount = 0;$whmcount2++;
		$extra_letter = substr($extra_letters, 0, $whmcount2);
		$username = substr($username, 0, -$whmcount3);$whmcount3++;$username = $username . $extra_letter . $whmcount;
		
		return $username;
		}
	if ($exit > 30) {$error = 'over 30 attempts'; goto EXITA2;}
return $username;
EXITA2:
return $error;
}
// **********Create a 14 alphanumeric password as resellerclub requires this type ************
function wcs_filter_password_auto( $args, $username ) {
    $new_password = wp_generate_password( 14, false);
     $args['user_pass'] = $new_password;
				$key  = 'qJB0rGtIn5UB1xG03efyCp';
				$data = $new_password;
				$encrypted = encryptIt( $data,$key );
	set_transient('resellerclub_password', $encrypted, 60*20);
    return $args;
}
add_filter( 'woocommerce_new_customer_data', 'wcs_filter_password_auto' );
// ******************Get new customers username and add password to it ******************
function wh_get_new_customer_data($customer_id, $new_customer_data, $password_generated ) {
  	$encrypted = get_transient('resellerclub_password');
	update_user_meta($customer_id, 'resellerclub_password', $encrypted);
   
}
add_action( 'woocommerce_created_customer', 'wh_get_new_customer_data',10,3);
function wh_update_domains_after_order_status($order_id)
{
global $woocommerce,$order_id,$a,$product_name,$httpResponse,$ordernumber;
	wh_get_order_details($a, $order_id);
	$order = new WC_Order($a);
	
		$items = $order->get_items();
		foreach ( $items as $item ) 
	{
		$producttype = false;
		$product_name = $item['name'];
		$product_id = $item['product_id'];
		$producttype = get_post_meta( $product_id, 'package',true);
	if (isset($producttype) && ($producttype == "domain") || ($producttype == "domain-renew"))
		{ 
	$domainreg = get_post_meta( $product_id, 'domain-registered',true);
	if (isset($domainreg) && ($domainreg == "no"))
			{
	wh_check_domains_order($product_name, $httpResponse);
	if (ctype_digit($httpResponse))
				{
				update_post_meta( $product_id, 'domain-registered', "yes");
				update_post_meta( $product_id, 'domain-registered-date', date("d/m/Y"));
				$years = get_post_meta( $product_id, 'domainyears',true);	
				$expirydate = date('d-m-Y', strtotime('+' . $years));
				update_post_meta( $product_id, 'domainexpiry', $expirydate );
				
				}
			}
		}		
	}
}
add_action('wh_update_domains_after_order_status','wh_update_domains_after_order_status');
function wh_check_domains_order($product_name, $httpResponse){
	global $api_user_id,$api_key,$product_id,$product_name,$httpResponse,$woocommerce,$order_id,$url,$str,$method,$rc_url;
	$url = 'https://' . $rc_url . 'httpapi.com/api/domains/orderid.json?';
$str ='auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&domain-name=' . $product_name;
$method = true;
CheckDomainCallAPI($method, $url, $data = false,$httpResponse);	
return	$httpResponse;
}
add_shortcode('wh_check_domains_order','wh_check_domains_order');
function check_hosting_in_cart($passed, $product_id , $quantity = '', $variation_id, $variations= '' )
{
	global $hosting_in_the_cart;
	global $woocommerce;
	$_categoryid = '';
		$product = wp_get_post_terms( $product_id, 'product_cat' );
		foreach ($product as $term) 
		{
		 $product_in_cart = $term->slug ;
		}
if (empty($product_in_cart)){ 
$product_id2 = wp_get_post_parent_id( $product_id );$product_id = $product_id2;
$product = wp_get_post_terms( $product_id, 'product_cat' );
		foreach ($product as $term) 
		{
		 $product_in_cart = $term->slug ;
		}
			}
	foreach ( $woocommerce->cart->get_cart() as $cart_item_key => $values ) 
	{
			
	$_product = $values['data'];
        $terms = get_the_terms( $_product->id, 'product_cat' );
			
           	foreach ($terms as $term) 
		{
                $_categoryid = $term->slug ;
if (isset($_categoryid) && ($_categoryid == 'hosting' ) && ($product_in_cart == 'hosting'))
			{
			$_categoryid = false;
			$opt_name_shoppingpage = 'wh_shoppingpage';
			$opt_val_shoppingpage = get_option( $opt_name_shoppingpage );
			$continueshopping = '<a href="' . $opt_val_shoppingpage . '">Continue Shopping</a>';
       			wc_add_notice( sprintf( __( "You cannot add more than 1 hosting package at a time. ",'woocommerce' ) ) ,'error' );
			return false;
					
			
	
			}
            
		
			
		} //foreach ($terms as $term) 
	} // foreach ( $woocommerce->cart->get_cart() as $cart_item_key => $values )
return $passed;
} // end of function
add_action('woocommerce_add_to_cart_validation', 'check_hosting_in_cart',10,5);



function CheckDomainCallAPI($method, $url, $data = false,$httpResponse){	
global $url,$data,$httpResponse,$method,$str;
if ($method == true){
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL,$url . $str);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	curl_setopt($ch, CURLOPT_POST,TRUE);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$httpResponse = curl_exec($ch);
}
else{
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	curl_setopt($ch, CURLOPT_POST,TRUE);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS,$str);
	$httpResponse = curl_exec($ch);
}
return $httpResponse;
}
// ********************************************************************************************
function woo_resellerclub_signup($djg_account_id,$customer_id)
{
global $djg_first_name,$djg_last_name,$djg_company_name,$djg_email,$djg_phone,$djg_country,$djg_phone_cc,
$djg_state,$djg_address_1,$djg_city,$djg_postcode,$djg_account_id,$contact_type,$customer_id,
$djg_user_password,$accountpassword,$product_id,$admin_id,$api_user_id,$api_key,$fulldomainname,
$randpassword,$url,$httpResponse,$str,$method,$rc_url;

PASSWD:	
		$httpResponse = '';
		$djg_account_id = false;
		$djg_account_id = get_user_meta( $customer_id, 'resellerclub_id', true );
$_product_name = get_the_title( $product_id );
		$user_info = get_userdata($customer_id);
		$username = $user_info->user_login;
		$djg_pass = get_user_meta($customer_id, 'resellerclub_password', true);
		$key  = 'qJB0rGtIn5UB1xG03efyCp';
		$data = $djg_pass;
		$decrypted = decryptIt( $data,$key );
		$djg_pass = $decrypted;
		$djg_pass = str_replace(' ', '', $djg_pass);
SIGNUP:
		$djg_pass_temp = preg_replace("/(\n|\r|\s)/", '', $djg_pass);
		$djg_pass = $djg_pass_temp;
		if ($djg_account_id == false) 
		{
		$djg_first_name = get_user_meta( $customer_id, 'billing_first_name', true );
		$djg_last_name = get_user_meta( $customer_id, 'billing_last_name', true );
		$djg_company_name = get_user_meta( $customer_id, 'billing_company_name', true );
			if ($djg_company_name == ''){$djg_company_name = 'n/a';}
		$djg_email = get_user_meta( $customer_id, 'billing_email', true );
		$djg_phone = get_user_meta( $customer_id, 'billing_phone', true );
			$djg_phone = str_replace(' ', '', $djg_phone);
		$djg_country = get_user_meta( $customer_id, 'billing_country', true );
			if ($djg_country == 'GB'){$djg_phone_cc = '44';}
		$djg_state = get_user_meta( $customer_id, 'billing_state', true );
		$djg_address_1 = get_user_meta( $customer_id, 'billing_address_1', true );
		$djg_city = get_user_meta( $customer_id, 'billing_city', true );
		$djg_postcode = get_user_meta( $customer_id, 'billing_postcode', true );
			if ($djg_pass == ''){if($count <4){$count++; goto PASSWD;}}
$url = 'https://' . $rc_url . 'httpapi.com/api/customers/signup.json?';
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&username=' . $djg_email . '&passwd=' . $djg_pass . '&name=' . $djg_first_name . ' ' . $djg_last_name . '&company=' . $djg_company_name . '&address-line-1=' . $djg_address_1 . '&city=' . $djg_city . '&state=' . $djg_state . '&country=' . $djg_country . '&zipcode=' . $djg_postcode . '&phone-cc=' . $djg_phone_cc . '&phone=' . $djg_phone . '&lang-pref=en';
	if ($djg_pass <> '')
	{
	$method = false;
	$data = CheckDomainCallAPI($method, $url, $str, $data = false);
	$httpResponse = $data;
		if (ctype_digit($httpResponse)) 
		{
		$djg_account_id = $httpResponse;
		$_POST['resellerclub_id'] = esc_attr ($djg_account_id);
		update_user_meta( $customer_id, 'resellerclub_id', sanitize_text_field( $_POST['resellerclub_id'] ) );
		}
		else
		{
			$datajson = json_decode($httpResponse, TRUE);
			$message = ($datajson["message"]);
	if ($message == '{passwd=Password should be alphanumeric characters with minimum of 8 characters and maximum of 15 characters}')
			{
			$random = random_password( $length = 14);
			$djg_pass = $random;
				$key  = 'qJB0rGtIn5UB1xG03efyCp';
				$data = $djg_pass;
				$encrypted = encryptIt( $data,$key );
			update_user_meta($customer_id, 'resellerclub_password', $encrypted);
			$randompasswordused = 'the random password was used';
goto SIGNUP;
			}
			}
			return $httpResponse;
	} // end of If ($djg_pass <> '')
} // end of if ($djg_account_id == false)
}
add_shortcode('woo_resellerclub_signup','woo_resellerclub_signup');
function woo_get_resellerclub_customers_info($admin_id,$contact_type,$djg_account_id,$product_id,$customer_id){
global $admin_id,$contact_type,$djg_account_id,$contact_company,$contact_telephone,$contact_id,
$contact_postcode,$contact_city,$contact_country,$contact_address1,$contact_telephone_cc,$contact_name,
$customer_id,$contact_state,$contact_email,$api_user_id,$api_key,$errormessage,$product_id,$domaintdl,
$api_user_id,$api_key,$url,$httpResponse,$str,$method,$rc_url;
$_product_name = get_the_title( $product_id );
$years = get_post_meta( $product_id, 'domainyears');
$years = $years[0];
$years = str_replace(' Years', '', $years);
$domaintdl = get_post_meta( $product_id, 'domaintld',true);
if ($domaintdl == '0'){$contact_type = 'Contact';}
if ($domaintdl == '1'){$contact_type = 'UkContact';}
if ($domaintdl == '2'){$contact_type = 'CoContact';}



$url = 'https://' . $rc_url . 'httpapi.com/api/contacts/default.json?';
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key .'&customer-id=' . $djg_account_id . '&type=' . $contact_type;
$method = true;
CheckDomainCallAPI($method, $url, $data = false,$httpResponse);
$temp = $httpResponse;
$result = json_decode($httpResponse, TRUE);
$httpResponse = $result;
$str = $temp;
// ***************** NEED TO GET CUSTOMERS DETAILS FROM RESELLERCLUB ***********************
// ***************** NEED TO USE JSON ON THE FIRST PART BUT KEPT GETTING ERRORS ************
// ***************** SO USED stripos INSTEAD ***********************************************
$colon = ":";
$bracket1 = "{";
$bracket2 = "}";
$position = stripos ($str, $colon); //find first bracket position
if($position) { //if there's a { colon in our source
        $offset = $position + 1; //prepare offset
	$position1 = stripos ($str, $colon, $offset); //find 2nd { colon position
$offset = $position1;
$offset2 = $offset;
	
$position2 = stripos ($str, $bracket2); //find 1st } bracket using offset
$offset = $position2 + 1; //prepare offset
$position2 = $position2 - $offset2;
	$last_bit = substr($str, $position1+1, $position2); 
$array = $last_bit;
$datajson = json_decode($array, TRUE);
$contact_company = $datajson['contact.company'];
if($contact_company == ''){$contact_company = 'n/a';}
$contact_telephone = $datajson['contact.telno'];
$contact_id = $datajson['contact.contactid'];
$contact_postcode = $datajson['contact.zip'];
$contact_city = $datajson['contact.city'];
$contact_country = $datajson['contact.country'];
$contact_address1 = $datajson['contact.address1'];
$contact_telephone_cc = $datajson['contact.telnocc'];
$contact_name = $datajson['contact.name'];
$djg_customer_id = $datajson['entity.customerid'];
$contact_state = $datajson['contact.state'];
$contact_email = ($datajson["contact.emailaddr"]);
$contact_type = $datajson['contact.type'];
}
return $httpResponse;
}
add_shortcode('woo_get_resellerclub_customers_info', 'woo_get_resellerclub_customers_info');
// ************************ RESELLERCLUB CUSTOMER ID **********************************
function woo_get_resellerclub_customers_id($contact_type,$admin_id,$djg_account_id){
global $contact_type,$admin_id,$contact_company,$contact_telephone,$contact_id,$contact_postcode,
$contact_city,$contact_country,$contact_address1,$contact_telephone_cc,$contact_name,$djg_account_id,
$contact_state,$contact_email,$api_user_id,$api_key,$domaintdl,$product_id,$httpResponse,$url,$str,$method,
$rc_url;
$_product_name = get_the_title( $product_id );






$url = 'https://' . $rc_url . 'httpapi.com/api/contacts/add.json?';
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&name=' . $contact_name . '&company=' . $contact_company . '&email=' . $contact_email . '&address-line-1=' . $contact_address1 . '&city=' . $contact_city . '&country=' . $contact_country . '&zipcode=' . $contact_postcode . '&phone-cc=' . $contact_telephone_cc . '&phone=' . $contact_telephone . '&customer-id=' . $djg_account_id . '&type=' . $contact_type;
$method = false;
CheckDomainCallAPI($method, $url, $data = false, $httpResponse);
if (ctype_digit($httpResponse)) {
$admin_id = $httpResponse;
return $admin_id;
}
else
{
$error = 'cannot get resellerclub account id';
$admin_id = false;
return $admin_id;
}
}
add_shortcode('woo_get_resellerclub_customers_id' , 'woo_get_resellerclub_customers_id');
function woo_register_domain($admin_id, $product_name, $domainresult, $djgmessage, $product_id, $ordernumber){
global $admin_id,$domainresult,$product_name,$djgtime,$djgmessage,$djg_userid,$wpdb,$product_id,
$contact_type,$contact_type_id,$djg_account_id,$api_user_id,$api_key,$years,$customer_id,$domainname,
$contact_company,$contact_telephone,$contact_id,$contact_postcode,$contact_city,$contact_country,
$contact_address1,$contact_telephone_cc,$contact_name,$djg_customer_id,$contact_state,$rc_url,
$contact_email,$errormessage,$domaintdl,$woocommerce,$ordernumber,$wh_nameserver01,$str,$method,
$wh_nameserver02,$wh_nameserver03,$wh_nameserver04,$new_or_transfer,$auth_code,$url,$httpResponse; 
$str = '';
$ch = '';
$ordernumber = false;
//// ****************************Register a domain or transfer with resellerclub  *********
$temp = get_post_meta( $product_id, 'package', true );
	if ($new_or_transfer == 'transfer'){
	$url = 'https://' . $rc_url . 'httpapi.com/api/domains/transfer.json?';
				   }
		else {$url = 'https://' . $rc_url . 'httpapi.com/api/domains/register.json?';}
	if ($temp == 'domain-renew'){
	
// ************** need to get order id here *****************************
$domainname = get_the_title( $product_id );
get_domain_order_details($httpResponse);
$datajson = $httpResponse;
	$ordernumber=$datajson["orderid"];
$url = 'https://' . $rc_url . 'httpapi.com/api/domains/renew.json?';
		if (isset($ordernumber)&&($ordernumber == true))
			{
			$new_or_transfer = 'renew';
			}else {$new_or_transfer = '';$domaintdl = '-1';}
			  	    }
$years = get_post_meta( $product_id, 'domainyears',true);
$yearstemp = str_replace('years', '', $years);
$years = str_replace(' ', '', $yearstemp);
if ($years == '0'){$years = '1';}
if (ctype_digit($years)) {}
else{$years = '1';}
if ($new_or_transfer == 'renew'){$domaintdl = '-1';
get_domain_order_details($httpResponse);
$exp_date = $httpResponse["endtime"];
$url = 'https://' . $rc_url . 'httpapi.com/api/domains/renew.json?';
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&order-id=' . $ordernumber . '&years=' . $years . '&exp-date=' . $exp_date . '&invoice-option=NoInvoice';
}
if ($new_or_transfer == 'transfer'){
$domaintdl = '-1';
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&domain-name=' . $product_name . '&auth-code=' . $auth_code . '&ns=' . $wh_nameserver01 . '&ns=' . $wh_nameserver02 . '&customer-id=' . $djg_account_id . '&reg-contact-id=' . $admin_id .'&admin-contact-id=' . $admin_id . '&tech-contact-id=' . $admin_id . '&billing-contact-id=' . $admin_id . '&invoice-option=NoInvoice';
}
if ($domaintdl == '1'){
	if ($rc_url == 'test.')	{
	$wh_nameserver01 = 'rclubuk.mercury.orderbox-dns.com';
	$wh_nameserver02 = 'rclubuk.venus.orderbox-dns.com';
				}
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&domain-name=' . $product_name . '&years=' . $years . '&ns=' . $wh_nameserver01 . '&ns=' . $wh_nameserver02 . '&customer-id=' . $djg_account_id . '&reg-contact-id=' . $admin_id . '&admin-contact-id=-1&tech-contact-id=-1&billing-contact-id=-1&invoice-option=NoInvoice';

}
if ($domaintdl == '2'){
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&domain-name=' . $product_name . '&years=' . $years . '&ns=' . $wh_nameserver01 . '&ns=' . $wh_nameserver02 . '&customer-id=' . $djg_account_id . '&reg-contact-id=' . $admin_id . '&admin-contact-id=' . $admin_id .'&tech-contact-id=' . $admin_id . '&billing-contact-id=' . $admin_id . '&invoice-option=NoInvoice&protect-privacy=false&cedcontactid=' . $admin_id;
}
if ($domaintdl == '0'){
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&domain-name=' . $product_name . '&years=' . $years . '&ns=' . $wh_nameserver01 . '&ns=' . $wh_nameserver02 . '&customer-id=' . $djg_account_id . '&reg-contact-id=' . $admin_id . '&admin-contact-id=' . $admin_id .'&tech-contact-id=' . $admin_id . '&billing-contact-id=' . $admin_id . '&invoice-option=NoInvoice&protect-privacy=false';
}
$datajson = '';
$httpResponse = '';
$url1 = $url;
$url = $url1 . $str;






		$data = CallDomainAPI('POST', $url, $data);
		$result = json_decode($data, TRUE);
		$httpResponse = $result;
	$datajson = $httpResponse;
	$user_ID = $customer_id;
	$djg_userid = $user_ID;
	set_transient('domain_checker_userid', $djg_userid, 60*20);
if ($datajson["status"] == "error")
	
  {
	$djgmessage = ($datajson["error"]);
   	$domainresult = false;
 
  }
if ($datajson["status"] == "ERROR"){
if ($datajson["message"] == "Domain already renewed.")
{



$domainresult = false;
return $domainresult;
}
$djgmessage = ($datajson["message"]);
}
if ($datajson["status"] == "Success")
{
	$domainresult = true;
	$djgmessage = ($datajson["actionstatusdesc"]);
	$ordernumber = ($datajson["entityid"]);
	update_option($ordernumber,$product_id);
	update_user_meta($customer_id, $product_name, $ordernumber);
	return $ordernumber;
}
 
if ($datajson["status"] == "AdminApproved")
{
	$domainresult = true;
	$djgmessage = ($datajson["actionstatusdesc"]);
	$ordernumber = ($datajson["entityid"]);
update_option($ordernumber,$product_id);
update_user_meta($customer_id, $product_name, $ordernumber);
 
 
	return $ordernumber;
}
}
add_shortcode('woo_register_domain','woo_register_domain');
function wh_wp_logout()
{
	if ( is_user_logged_in() )	{?><div class="wp_login">
	<a href="<?php echo wp_logout_url( home_url() ); ?>" title="Log out"> Log out</a>
	</div><?php
					} 
}
add_shortcode('wh_wp_logout', 'wh_wp_logout');
function wh_extra_fields() 
{
	global $woocommerce, $post, $wpdb, $order, $product, $fulldomainname, $wh_hostingpage, $wh_addonspage, $wh_domainspage, $product_name, $whm_port, $whm_ip, $whm_cp_port, $whm_ip_address, $domainreg;
$domainreg = false;
wh_check_domain_is_reg($order_id);
	
	$myaccountorders=0;
	$myaccountdomains=1;
	$count='0';
	if ( is_user_logged_in() )
{
	?>
	<div class="myaccountpage">
	<a href="<?php echo site_url();?>/my-account">&lArr; My Account</a>
	<div class="my-account-menu">
	<ul style ="list-style-type: none;float:right;">
	<li style ="display: inline;padding-left:10px;"><a href="#domains">Domains</a></li>
	<li style ="display: inline;padding-left:10px;"><a href="#hosting">Hosting</a></li>
	<li style ="display: inline;padding-left:10px;"><a href="#addons">Add-ons</a></li>
<?php
if( wh_woocommerce_version_check() ) {}
else{
?>
<li style ="display: inline;padding-left:10px;"><a href="#orders">Orders</a></li>
<?php
}
?>
	</ul><br /><br />
	</div>
	<div class="my-account-layout-hosting">
	<div class="my-account-firstname">
	<?php
	$customer_id = get_current_user_id();
if (current_user_can('customer') || (current_user_can('administrator') )){ 
	echo '<br />Hello <b>' . get_user_meta( $customer_id, 'billing_first_name', true ); echo '</b> From your account controlpanel you can manage your domains, hosting packages and addons.';
	echo '<br /><br /><hr><br />';
	?>
	</div>
	<A NAME="domains"></a>
	
	<h3> Domains </h3>
	<div class="package-names">
	<?php
	$djg_resellerclub_id = get_user_meta( $customer_id, 'resellerclub_id', true );
	if (isset($djg_resellerclub_id) && ($djg_resellerclub_id <> ''))
{
	
	?>
	<a href="http://sale591380.myorderbox.com/customer">Resellerclub Account Number:</a>
	<?php echo esc_html ($djg_resellerclub_id);
	
}
	?>
<?php
	
	$path = site_url();
$cpanelimg = content_url('/plugins/web-hosting/images/cpanel54x26.png' , __FILE__ );	
	?>
	<br />
	<?php
	$recent_orders = '-1';
	$args = array(
	    'numberposts'     => $recent_orders,
	    'meta_key'        => '_customer_user',
	    'meta_value'	  => $customer_id,
	    'post_type'       => 'shop_order',
	    'post_status'     => 'publish'
	);
	$customer_orders = get_posts($args);
	if ($customer_orders)
{
	foreach ($customer_orders as $customer_order) :
				$order = new WC_Order();
				$order->populate( $customer_order );
				$status = get_term_by('slug', $order->status, 'shop_order_status');
				$you_have_got_a_domain = false;
$count = false;			$paid = $customer_order->post_status;
	
		foreach($order->get_items() as $item) 
		{
		$product_name = $item['name'];
		$product_id = $item['product_id'];
		$domain = get_post_meta( $product_id, 'package',true);
		$domainreg = false;
			if (isset($domain) && ($domain == "domain") || ($domain == "domain-renew") )
			{
if ($domains_array[$count] <> $product_id){
$domains_array[] = $product_id;
$count++;
			$havedomain = true;
	$you_have_got_a_domain = true;$domainreg = get_post_meta( $product_id, 'domain-registered',true);
	echo 'Domain Name: &nbsp; ' . esc_html ($product_name) . '  &nbsp; Domain Expires: ' . get_post_meta( $product_id, 'domainexpiry', true );?>
	<br />
	<div class="managedomain">
	<?php 	

		echo '<br />Domain Registered  ' . get_post_meta( $product_id, 'domain-registered', true );
domain_edits($product_name,$domainreg);
echo '</div>';
	if ($havedomain == true){echo '<hr><br />';}
} // end of if ($domains_array[$count] <> $product_id;	
}
}
	endforeach;
}
	if ($havedomain == false)	{
?>You have no domain <a href="<?php echo esc_html($wh_domainpage); ?>"><div class="wh_button">Order</a></div><?php
					}
	?></div></div>
	<hr><br /><br />
	<A NAME="hosting"></a>
	<div class="my-account-layout-hosting">
	<h3> Hosting Packages </h3><br /><br />
	<div class="package-names"><div class="managehosting">
	<?php $paid = false;
	$same_product_id = array();
	$customer_orders = get_posts($args);
	if ($customer_orders)
{
		foreach ($customer_orders as $customer_order) :
		$order = new WC_Order();
		$order->populate( $customer_order );
		$status = get_term_by('slug', $order->status, 'shop_order_status');
		$paid = $customer_order->post_status;
			foreach($order->get_items() as $item) 
   			   {
				$product_name = $item['name'];
				$product_id = $item['product_id'];
				$hosting = get_post_meta( $product_id, 'package',true);
			if ($hosting == "hosting")
		        {$havehosting = true;
				if (in_array($product_name, $same_product_id)) {goto gotit;}
	if ($paid == 'wc-completed')	{
	echo 'Package ' . esc_html ($product_name) . '<br /> ' ;
	$havehosting = true;
					}
else{echo 'Package ' . esc_html ($product_name) . ' we are awaiting payment<br />';}
        
}
array_push($same_product_id,$product_name);
gotit:
     }
	endforeach;
	$same_product_id = '';
if ($havehosting == true){
echo '<br /><br />Login to Cpanel '; ?>&nbsp;&nbsp;<a href="https://<?php echo esc_html	($whm_ip_address) . ':' . esc_html ($whm_cp_port); ?>" target="_blank"><img src="<?php echo esc_url ($cpanelimg) ?>"></a><br /><br /> <?php
} 
}
if ($havehosting == false){
?>You have no hosting <a href="<?php echo esc_html ($wh_hostingpage); ?>"><div class="wh_button">Order</a></div><?php
}
	?>
</div>
	</div>
	</div>
	<!-- </div> -->
	<br />
	<br />
	<br />
	<hr>
	<br />
	<A NAME="addons"></a>
	<div class="my-account-layout-hosting">
	<h3> Addons</h3><br /><br />
	<div class="package-names">
	<?php
	$count=0;
	$addon = false;
	$customer_orders = get_posts($args);
	if ($customer_orders)
{
	foreach ($customer_orders as $customer_order) :
				$order = new WC_Order();
				$order->populate( $customer_order );
	$status = get_term_by('slug', $order->status, 'shop_order_status');
	foreach($order->get_items() as $item) 
   {	$addons = '';
	$product_name = $item['name'];
	$product_id = $item['product_id'];
	$addons = get_post_meta( $product_id, 'package',true);
	if ($addons == "addon")
      {
	echo 'Addon ' . esc_html($product_name) . '<br />'; $addon = true;
      }
   }
	endforeach;
}
if ($addon == false)
{
echo 'You have no addons'; ?> <a href="<?php echo esc_html($wh_addonspage); ?>"><div class="wh_button">Order</a></div><?php
}
	?>
	</div>
	</div>
	<!-- </div> -->
	<br />
	<br />
	<br />
	<hr>
	<br />
	<A NAME="orders"></a>
	<?php 
edit_domains();
} // end of if (current_user_can() 
} // end if if user is logged in 
}
add_shortcode('wh_extra_fields', 'wh_extra_fields');
function edit_domains(){
global $woocommerce,$post,$wpdb,$order,$product,$fulldomainname,$product_id,$ns1,$ns2,$ns3,$ns4,
$errormessage,$domainname,$lock,$pageposition;
	if ( is_user_logged_in() ) 
{


if (current_user_can('customer')){




	$customer_id = get_current_user_id();
	$recent_orders = '';
	$args = array(
    'numberposts'     => $recent_orders,
    'meta_key'        => '_customer_user',
    'meta_value'	  => $customer_id,
    'post_type'       => 'shop_order',
    'post_status'     => 'publish'
	);
	$customer_orders = get_posts($args);
		foreach ($customer_orders as $customer_order) :
				$order = new WC_Order();
				$order->populate( $customer_order );
		$status = get_term_by('slug', $order->status, 'shop_order_status');
			foreach($order->get_items() as $item) {
			$product_name = $item['name'];
			$product_id = $item['product_id'];
			$domainexpiry = get_post_meta( $product_id, 'domainexpiry');
			$domainreg = get_post_meta( $product_id, 'domain-registered',true);

}

endforeach;
echo '<A NAME="' . esc_html ($pageposition) .'"></a>';
	if (isset($_POST['checkns'])){

$retrieved_nonce = $_REQUEST['_wpnonce'];
if (!wp_verify_nonce($retrieved_nonce, 'wh_checkns' ) ) die( 'Sorry security token has expired' );




$ns1 = false; $ns2 = false;
	$domainname = sanitize_text_field ($_POST['product_name']);

	$ns1 = sanitize_text_field ($_POST['ns1']);
if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $ns1)) 
	{echo '<div class ="whmessageboxred">Error nameserver 01 has not been updated incorrect format used</div>';$error=true;return;}

	$ns2 = sanitize_text_field ($_POST['ns2']);
if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $ns2)) 
	{echo '<div class ="whmessageboxred">Error nameserver 02 has not been updated incorrect format used</div>';$error=true;return;}

	$ns3 = sanitize_text_field ($_POST['ns3']);
if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $ns3)) 
	{echo '<div class ="whmessageboxred">Error nameserver 03 has not been updated incorrect format used</div>';$error=true;return;}

	$ns4 = sanitize_text_field ($_POST['ns4']);
if (!preg_match("/\b(?:(?:ns?)[0-9]\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $ns4)) 
	{echo '<div class ="whmessageboxred">Error nameserver 04 has not been updated incorrect format used</div>';$error=true;return;}

	$page = get_page_by_title( $domainname,'','product' );
	$product_id = $page->ID;
 
		if ($ns1 == false){
	$errormessage = 'Name Server 1 requires a valid name';
		if ($ns2 == false){
	$errormessage = 'Name Server 1 and Name Server 2 require valid names';
				}
				}
	if ($ns2 == false)	{
	$errormessage = 'Name Server 2 requires a valid name';
	if ($ns1 == false)	{
	$errormessage = 'Name Server 1 and Name Server 2 require valid names';
				}
				}
update_nameservers_api($product_id);
}
	if (isset($_POST['select'])){ 

$retrieved_nonce = $_REQUEST['_wpnonce'];
if (!wp_verify_nonce($retrieved_nonce, 'wh_domain_options_form' ) ) die( 'Sorry security token has expired' );



	$domainaction = sanitize_text_field ($_POST['select']);
		if ($domainaction == 'Change Nameservers'){
		$domainname = sanitize_text_field ($_POST['product_name']);
		$customer_id = get_current_user_id();
	$args = array(
    'numberposts'     => $recent_orders,
    'meta_key'        => '_customer_user',
    'meta_value'	  => $customer_id,
    'post_type'       => 'shop_order',
    'post_status'     => 'publish'
	);
		$customer_orders = get_posts($args);
echo '<A NAME="' . esc_html ($pageposition) .'"></a>';
echo '<h4>Nameservers</h4><br />' . esc_html($domainname) . '<br /><br />';
			foreach ($customer_orders as $customer_order) :
				$order = new WC_Order();
				$order->populate( $customer_order );
			$status = get_term_by('slug', $order->status, 'shop_order_status');
			$s='1';
			foreach($order->get_items() as $item) {
				$product_name = $item['name'];
				$product_id = $item['product_id'];
	while($s <= 4 && $product_name == $domainname) 
{
	echo 'Nameserver' . esc_html ($s) .': &nbsp; ' . get_post_meta( $product_id, 'nameserver0'.esc_html($s), true );
	echo '<br />';$s++;$tempdomainname = $product_id;
}
}
endforeach;
?><br /><br />
<?php

$path = get_permalink( $post->ID );
echo '<form method="post" action="' .esc_attr ($path) . '#' . esc_html($pageposition) . '">' ; ?>
<?php wp_nonce_field('wh_checkns'); ?>
<input type="hidden" name="product_name" value=<?php echo esc_html($domainname);?> >
<table>
<tr>
<th style="border:0px;">
<p>Name Server 1*</p><p><input type="text" name="ns1" pattern="[a-z0-9.-]+\.[a-z]{2,3}$"></p>
</th>
<th style="border:0px;">
<p>Name Server 2*</p><input type="text" name="ns2" pattern="[a-z0-9.-]+\.[a-z]{2,3}$"></p>
</th>
</tr>
<tr>
<th style="border:0px;">
<p>Name Server 3</p><input type="text" name="ns3" pattern="[a-z0-9.-]+\.[a-z]{2,3}$"></p>
</th>
<th style="border:0px;">
<p>Name Server 4</p><input type="text" name="ns4" pattern="[a-z0-9.-]+\.[a-z]{2,3}$"></p>
</th>
</tr>
<tr>
<th style="border:0px;padding-top:10px;">
    <input type="submit" name="checkns" value="Change"/>
</th>
</tr>
</table>
</form>
<?php
} // end of isset($_POST['select']))
}
if (isset($domainaction) && ($domainaction == 'Domain Secret')){
//$domainname = $_GET['domain'];
$domainname = sanitize_text_field ($_POST['product_name']);
echo '<A NAME="' . esc_html ($pageposition) .'"></a>';
echo '<h3>Domain</h3>';
echo 'Domain: ' . esc_html($domainname);
domain_secret_api($domainname);
}
if (isset($domainaction) && ($domainaction == 'Unlock Domain')){

$domainname = sanitize_text_field ($_POST['product_name']);
echo '<h3>Domain</h3>';
echo 'Domain: ' . esc_html($domainname);
$lock='disable';
unlock_domain_api($lock);
}
if (isset($domainaction) && ($domainaction == 'Lock Domain')){
$domainname = sanitize_text_field ($_POST['product_name']);
echo '<h3>Domain</h3>';
echo 'Domain: ' . esc_html($domainname);
$lock='enable';
unlock_domain_api($lock);
}
} // end of if (current_user_can('customer')){
} // end of user logged in
else {echo 'please login to view this page';}
}
add_shortcode('edit_domains','edit_domains');









function domain_edits($product_name,$domainreg){
global $product_name, $domainreg, $pageposition;
if (current_user_can('customer')){
if ($domainreg == 'yes'){
			?>
<table style="width:50%;">
<?php
$pageposition = 'result';
$path = get_permalink( $post->ID );

echo '<form method="post" action="' . esc_attr ($path) . '#' . esc_attr ($pageposition) . '">' ; ?>
<tr>
<td style="border: 0px">
<input type="hidden" name="product_name" value=<?php echo esc_attr ($product_name);?> >
<?php wp_nonce_field('wh_domain_options_form'); ?>
<select name="select" value="select">  
<option>select</option>
<option>Change Nameservers</option>
<option>Domain Secret</option>
<option>Unlock Domain</option>
<option>Lock Domain</option>
</select>
</td>
<td style="border: 0px">
    <input type="submit" name="check" value="Go"/>
</td>
</tr>
</form>
</table>
<?php
} // end of if ($domainreg == 'yes'){
} // end of if (current_user_can('customer')){
}
add_action('domain_edits','domain_edits');






function update_nameservers_api($product_id){
global $product_id,$api_user_id,$api_key,$domainname,$ns1,$ns2,$ns3,$ns4,$errormessage,$url,
$entityid,$order_id,$httpResponse,$str,$method,$rc_url;

	if ($ns1 == true && $ns2 == true){
	$domainname = get_the_title( $product_id );
	$customer_id = get_current_user_id();
	$order_id = get_user_meta($customer_id, $domainname, true); 
		if ($ns4 && $ns3){
		$nameserver = '&ns=' . $ns1 . '&ns=' . $ns2 . '&ns=' . $ns3 . '&ns=' . $ns4;
				}
		if ($ns3 && $ns4 == ''){
		$nameserver = '&ns=' . $ns1 . '&ns=' . $ns2 . '&ns=' . $ns3;
					}
		if ($ns2 && $ns3 == ''){
		$nameserver = '&ns=' . $ns1 . '&ns=' . $ns2;
					}
RETRY2:
$url1 = 'https://' . $rc_url . 'httpapi.com/api/domains/modify-ns.json?';
$str= 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&order-id=' . $order_id  . $nameserver;
$url = $url1 . $str;

$data = CallDomainAPI('POST', $url, $data);
$datajson = json_decode($data, TRUE);
$status = ($datajson["status"]);

if ($status == 'Success'){
update_post_meta( $product_id, 'nameserver01', $ns1 );
update_post_meta( $product_id, 'nameserver02', $ns2 );
update_post_meta( $product_id, 'nameserver03', $ns3 );
update_post_meta( $product_id, 'nameserver04', $ns4 );
echo ' Nameserver for ' . esc_html ($domainname) . ' has been completed please allow upto 72 hours for changes to take effect';
}
else
{ 
if ($djgtime == 4){
echo 'nameservers was not updated please check you are using a valid name and try again<br />';
}
$djgtime++;
if ($djgtime <= 4){ 
sleep(5);
goto RETRY2;
}
}
} // end of ($ns1 == true)
else {$errormessage = 'ns1 is empty';}
if ($errormessage){echo 'nameservers was not updated<br />' . esc_html ($errormessage);}
}

add_action('update_nameservers_api', 'update_nameservers_api');
function domain_secret_api($domainname){
global $domainname,$api_user_id,$api_key,$httpResponse;
	get_domain_order_details($httpResponse);
	$domain_secret=$httpResponse["domsecret"];
		if ($domain_secret)	{
echo '<br /><b>Domain Secret</b><br /> ' . esc_html ($domain_secret) . '<br />Authorisation code to transfer the Domain Name<br /><br />';
echo 'After you have noted the authorisation code, you will then need to provide this code to the new registrar that you wish to transfer your domain to. They will be able to advise you on their steps to transfer the domain to them.<br /> Once the transfer is approved it can take upto 7 days to transfer.';
					}
}
add_action('domain_secret_api','domain_secret_api');
function unlock_domain_api($lock){
global $api_user_id,$api_key,$datajson,$lock,$url,$str,$method,$httpResponse,$rc_url;
	get_domain_order_details($httpResponse);

	$domain_order_id=$httpResponse["orderid"];
		if ($domain_order_id){
$url1 = 'https://' . $rc_url . 'httpapi.com/api/domains/' . $lock . '-theft-protection.json?';
$str ='auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&order-id=' . $domain_order_id;
$url = $url1 . $str;
$data = CallDomainAPI('POST', $url, $data);
$datajson = json_decode($data, TRUE);
		$status = ($datajson["status"]);
		if ($status == 'Success'){
		if ($lock == 'enable'){echo '<a name="result"></a><br />Domain has been Locked';}
		if ($lock == 'disable'){echo '<br />Domain has been Unlocked';}
					}
}
}
add_action('unlock_domain_api','unlock_domain_api');
function get_domain_order_details($httpResponse){
global $domainname,$api_user_id,$api_key,$datajson,$httpResponse,$url,$str,$method,$rc_url;
$url1 = 'https://' . $rc_url . 'httpapi.com/api/domains/details-by-name.json?';
$str = 'auth-userid=' . $api_user_id . '&api-key=' . $api_key . '&domain-name=' . $domainname . '&options=OrderDetails';
$url = $url1 . $str;
    $data = "";
    $data = CallDomainAPI('GET', $url, $data);
    $httpResponse = json_decode($data, TRUE);
return $httpResponse;
}
add_action ('get_domain_order_details','get_domain_order_details');
function woo_filter_state_billing( $address_fields ) { 
  $address_fields['billing_state']['required'] = true;
	return $address_fields;
}
add_filter( 'woocommerce_billing_fields', 'woo_filter_state_billing', 10, 1 );
function woo_filter_state_shipping( $address_fields ) { 
	$address_fields['shipping_state']['required'] = true;
	return $address_fields;
}
add_filter( 'woocommerce_shipping_fields', 'woo_filter_state_shipping', 10, 1 );
function wh_wc_change_state_label_locale($locale){
    
  
    $locale['GB']['state']['label'] = __('County <span style ="color:#ff0000;border-bottom:1px dotted #ff0000;
    text-decoration: none;">*</span>', 'woocommerce');
    return $locale;
}
add_filter('woocommerce_get_country_locale', 'wh_wc_change_state_label_locale');
function wh_filter_addons_field($fields){
    $fields['ssl_fields'] = array(
            'ssl_field' => array(
                'type' => 'text',
		'pattern' => '[a-z0-9.-]+\.[a-z]{2,3}$',
                'required'      => false,
                'label' => __( 'As you are purchasing an SSL certificate we required a domain name to go with your certificate' )
                
                )
            );
   return $fields;}
add_filter( 'woocommerce_checkout_fields', 'wh_filter_addons_field' );
function wh_filter_hosting_field($fields){
    $fields['hosting_fields'] = array(
            'domain_field' => array(
                'type' => 'text',
		'pattern' => '[a-z0-9.-]+\.[a-z]{2,3}$',
                'required'      => false,
                'label' => __( 'As you have not purchased a domain we required a domain name for your hosting package' )
                
                )
            );
   return $fields;}
add_filter( 'woocommerce_checkout_fields', 'wh_filter_hosting_field' );
 
function wh_checkout_fields($fields)
{ 
global $woocommerce;
global $fulldomainname;
global $domain_in_cart;
global $domain_in_cart_id;
	// Get current items in the cart
$ssl_in_cart = 'false';
$hosting_in_cart = 'false';
$domaincount = 0;
	  $items = $woocommerce->cart->get_cart();
	  foreach($items as $item => $values) 
	{ 
          $_product = $values['data']->post;
	  $name = $_product->post_title;
	  $id = $_product->ID;
// ***************************see what products there is ***********************
		$type = get_post_meta( $id, 'package',true);
		$producttype = get_post_meta( $id, 'producttype',true);
	if (isset($producttype) && ($producttype == "ssl")){$ssl_in_cart = 'true';}
	if (isset($type) && ($type == "hosting")){$hosting_in_cart = 'true';}
		
		if (isset($type) && ($type == "domain")){$domain_in_cart = 'true';$domaincount++;}
		update_option('wh_checkout_field_name' , $domain_in_cart );
		update_option('wh_checkout_field_id' , $id );
	} 
	  	  $checkout = WC()->checkout(); ?>
	  	  
	 	   <?php 
   		 
if (isset($hosting_in_cart) && ($hosting_in_cart =='true') && ($domain_in_cart == false))
{
	    foreach ( $checkout->checkout_fields['hosting_fields'] as $key => $field ) : ?>
            <?php woocommerce_form_field( $key, $field, $checkout->get_value( $key ) ); ?>
	    <?php endforeach;
}
if (isset($ssl_in_cart) && ($ssl_in_cart == 'true') && ($domain_in_cart == false))
{
	    foreach ( $checkout->checkout_fields['ssl_fields'] as $key => $field ) : 
            woocommerce_form_field( $key, $field, $checkout->get_value( $key ) );
	    endforeach;
}
if (isset($ssl_in_cart) && ($ssl_in_cart == 'true') && ($domain_in_cart == true) && ($domaincount == 1))
{		echo '<b>If you are using the domain that is in your cart then leave this blank</b>';
	    foreach ( $checkout->checkout_fields['ssl_fields'] as $key => $field ) : 
            woocommerce_form_field( $key, $field, $checkout->get_value( $key ) ); 
	    endforeach;
}
if (isset($ssl_in_cart) && ($ssl_in_cart == 'true') && ($domain_in_cart == true) && ($domaincount > 1))
{		echo '<b>If you are using one of the domains that is in your cart then please tell us which one</b>';
	    foreach ( $checkout->checkout_fields['ssl_fields'] as $key => $field ) : 
            woocommerce_form_field( $key, $field, $checkout->get_value( $key ) ); 
	    endforeach;
}
		?><br /><hr>
<?php
}
add_action( 'woocommerce_checkout_before_customer_details' ,'wh_checkout_fields');
 
function wh_save_checkout_fields( $order_id, $posted){
global $wpdb;
global $a;
global $order_id;
$product_id = get_option('wh_checkout_field_id' , true );
$domain_in_cart = get_option('wh_checkout_field_name' , true );
$ssl_in_cart = get_option('wh_ssl_domainname' , true );
 
wh_get_order_details($a, $order_id);
	$order = new WC_Order($a);
	$items = $order->get_items();
		foreach ( $items as $item ) {
		    $product_name = $item['name'];
	$domain = get_post_meta($product_id,'package',true);
		if ($domain == 'domain'){
		
		update_post_meta( $a, '_domain_field', $product_name );
		 } 
if( isset( $posted['domain_field'] ) && ($domain_in-cart == false) ) {
        update_post_meta( $a, '_domain_field', sanitize_text_field( $posted['domain_field'] ) );
}
if( isset( $posted['ssl_field'] )) {
        update_post_meta( $a, '_ssl_domain_field', sanitize_text_field( $posted['ssl_field'] ) );
}
}
delete_option('wh_checkout_field_name');
delete_option('wh_checkout_field_id');
}
add_action( 'woocommerce_checkout_update_order_meta', 'wh_save_checkout_fields', 10, 2 );
function wh_display_order_data_in_admin( $order ){  ?>
    <div class="order_data_column">
        <h4><?php _e( 'Extra Details', 'woocommerce' ); ?></h4>
        <?php 
           echo '<p><strong>' . __( 'SSL Domain ' ) . ': </strong>' . get_post_meta( $order->id, '_ssl_domain_field', true ) . '</p>';
 ?>
    </div>
<?php }
add_action( 'woocommerce_admin_order_data_after_order_details', 'wh_display_order_data_in_admin' );
function decryptIt($data, $key) {
    $key = md5($key);
    $data = base64_decode($data);
    $decrypted = mcrypt_decrypt(MCRYPT_RIJNDAEL_256,
        $key, $data, MCRYPT_MODE_CBC, md5($key));
    $decrypted = rtrim($decrypted, "\0");
    return $decrypted;
}
function encryptIt($data, $key) {
    $key = md5($key);
    $encrypted = mcrypt_encrypt(MCRYPT_RIJNDAEL_256,
        $key, $data, MCRYPT_MODE_CBC, md5($key));
    $encrypted = base64_encode($encrypted);
    return $encrypted;
}
function wh_complete_order($order_id){
$order = new WC_Order( $order_id );
$paid_status = get_post_meta($order->id,'_transaction_id', true);
if (isset($paid_status) && ($paid_status <> '')){
if ($order->status == 'processing'){$order->update_status( 'completed' );
}
}
}
add_action ('woocommerce_payment_complete','wh_complete_order', 20,3);
function wh_display_email_order_meta( $order, $sent_to_admin, $plain_text) {
global $wpdb, $djgmessage, $new_or_transfer,$data, $key;
global $whm_ip;
global $whm_servername;
global $whm_ip_address;
global $whm_cp_port;
global $woocommerce;
global $email_heading;
global $wh_newinvoice_email;
$orderid = $order->id;
$invoice_type = false;
$email_status = get_transient('email_status');
if (get_transient('email_status') <= '0'){$count++; set_transient('email_status', $count, 60*5);
	$user_id = $order->user_id;
	$orderid = $order->id;
	$paid = $order->post_status;
$invoice_type = get_post_meta($order->id, '_invoice_type', true);
if ($invoice_type == false){
	$domain1 = get_post_meta($orderid, '_domain_field',true);
	
if (isset($paid) && ($paid == 'wc-completed'))
{
	
wh_check_domain_is_reg($order_id);
global $email_heading; $email_heading = 'Order Complete';
		$items = $order->get_items();
		foreach ( $items as $item ) 
	{
		$producttype = false;
		$type = false;
		$product_name = $item['name'];
		$product_id = $item['product_id'];
		
		$producttype = get_post_meta( $product_id, 'package',true);
		$type = get_post_meta( $product_id, 'producttype',true);
if (isset($type) && ($type == "ssl"))
{
echo '<hr> <h4> SSL Certificate  </h4>';
$ssl_info = 'domain:' . get_post_meta( $order->id, '_ssl_domain_field', true );
}		
		if (isset($producttype) && ($producttype == "domain"))
	   {
	
		$domain1 = get_the_title( $product_id );$url = $domain1;
		$nameserver1 = get_post_meta( $product_id, 'nameserver01',true );
		$nameserver2 = get_post_meta( $product_id, 'nameserver02',true );
		$nameserver3 = get_post_meta( $product_id, 'nameserver03',true );
		$nameserver4 = get_post_meta( $product_id, 'nameserver04',true );
		if ($username == ''){
				    $username_name = 'WHM_' . $domain1;
				    $username = get_user_meta($user_id, $username_name, true );      
				    }
 			// Domain info
			if( $plain_text ){
			if( $domain1)
			{
			if ($new_or_transfer == 'new')
			  {
			  echo '"Domain:\r\n\r\nWebsite Url when domain has propagated http://www.' . esc_html ($domain1) . '\r\n\r\n"';}
			 }else {
				echo 'Domain Status: ' . esc_html ($djgmessage);
			   	}
			} else {
			if( $domain1)
			{
			if ($new_or_transfer == 'new')
			  {
			  echo '<br /><br /><h4>Domain:</h4><b>Website Url when domain has propagated <a href="http://www.' . esc_url ($domain1) . '/"> http://www.' . esc_html ($domain1) . '</a></b><br />';
			  }else {
			   	echo '<b>Domain Status: ' . esc_html ($djgmessage) . '</b>';
			   	}
			}
 			}
		
		// Hosting info
	   }
		if (isset($producttype) && ($producttype == "hosting"))
	   {
		$current_domain = get_post_meta($order->id, '_wh_domainname_field', true );
			$username_name = 'WHM_' . $current_domain;
			$username = get_user_meta($user_id, $username_name, true );
			$username = str_replace(".", "", $username);
		$details = get_user_meta( $user_id, '_whm_account' . $username, true );
				$username = $details["username"];
				$key = $details["key"];
				$data = $details["password"];
			$decrypted = decryptIt( $data,$key );
			$accountpassword = $decrypted;
			 
			if ($domain1 == ''){ $domain1 = $current_domain;
			
			
			}
		if( $plain_text ){
				echo '"Cpanel Username: ' . esc_html ($username) . '\r\n\r\n Cpanel Password: ' . esc_html ($accountpassword) . '\r\n\r\n Cpanel login: http://www.' . esc_html ($domain1) . ':<?php echo esc_html ($whm_cp_port); ?>\r\n\r\nWebsite Url when domain has propagated http://www.' . esc_url ($domain1) . '\r\n\r\n"';
				echo 'Temporary Cpanel login:http://' . esc_html ($whm_ip_address) . ':<?php echo esc_html ($whm_cp_port); ?>\r\n\r\n';
				echo 'Server Name: ' . esc_html ($whm_servername) . '\r\n\r\n';
				echo 'Server Address: ' . esc_html ($whm_ip_address) . '\r\n\r\n';
				echo 'Server IP: ' . esc_html ($whm_ip) . '\r\n\r\n';
				echo 'If you are using an existing domain with your new hosting account, you will need to update the nameservers to point to the nameservers listed below.<br />';
				echo 'Nameserver 1 ' . esc_html ($nameserver1) . '\r\n\r\n';
				echo 'Nameserver 2 ' . esc_html ($nameserver2) . '\r\n\r\n';
				echo 'Nameserver 3 ' . esc_html ($nameserver3) . '\r\n\r\n';
				echo 'Nameserver 4 ' . esc_html ($nameserver4) . '\r\n\r\n';
				echo 'SSL: ' . esc_html ($ssl_info) . '\r\n\r\n';
				echo 'ftp Hostname ' . 'ftp.' . esc_html ($domain1) . '\r\n\r\n';
				echo 'POP3 Host Address: mail.' . esc_html ($domain1) . '\r\n\r\n';
				echo 'SMTP Host Address: mail.' . esc_html ($domain1) . '\r\n\r\n';
		}
		else{
				
				echo '<h4>Cpanel Details</h4><b> Username: ' . esc_html ($username) . '<br />Cpanel Password: ' . esc_html ($accountpassword) . '<br />Cpanel login: http://www.' . esc_html ($domain1) . ':' . esc_html ($whm_cp_port) . '</b><br />';
				echo '<b>Temporary Cpanel login:https://' . esc_html ($whm_ip_address) . ':' . esc_html ($whm_cp_port) . '</b><br />';
				echo '<b>Temporary Site Access http://' . esc_html ($whm_ip) . '/~' . esc_html ($username) . '/</b><br />';
				echo '<h4>Server Settings</h4>';
				echo '<b>Server Name: ' . esc_html ($whm_servername) . '<br />';
				echo 'Server Address: ' . esc_html ($whm_ip_address) . '<br /><hr>';
				echo 'Server IP: ' . esc_html ($whm_ip) . '<br /><hr>';
if ($nameserver1 <>''){
				echo 'If you are using an existing domain with your new hosting account, you will need to update the nameservers to point to the nameservers listed below.<br />';
				echo 'Nameserver 1 ' . esc_html ($nameserver1) . '<br />';
				echo 'Nameserver 2 ' . esc_html ($nameserver2) . '<br />';
				echo 'Nameserver 3 ' . esc_html ($nameserver3) . '<br />';
				echo 'Nameserver 4 ' . esc_html ($nameserver4) . '<br /></b><hr>';
				
}
				echo '<h4>FTP Settings</h4>';
				echo '<b>ftp Hostname ' . '"ftp.' . esc_html ($domain1) . '"<br />';
				echo 'ftp password same as Cpanel password<br /></b><hr>';
				echo '<h4>Email Settings</h4>';
				echo '<b>POP3 Host Address: mail.' . esc_html ($domain1) . '<br />';
				echo 'SMTP Host Address: mail.' . esc_html ($domain1) . '<br /></b>';
		  		}
	   } // end of 	if (isset($producttype) && ($producttype == "hosting"))
if (isset($type) && ($type == "ssl")){echo '<b>SSL: ' . esc_html ($ssl_info) . '</b><br />';}
	} // end of foreach ( $items as $item )
 } // end of  if ($paid == 'wc-completed') 
} //end of if ($invoice_type == false)
}
//emailexit:
} // end of function
add_action('woocommerce_email_customer_details', 'wh_display_email_order_meta', 10, 4 );
function wh_get_order_details($a, $order_id){
global $woocommerce;
global $a;
global $order_id;
$customer_orders = get_posts( apply_filters( 'woocommerce_my_account_my_orders_query', array(
    'numberposts' => $order_count,
    'meta_key'    => '_customer_user',
    'meta_value'  => $customer_id,
    'post_type'   => 'shop_order',
    'post_status' => 'publish'
) ) );
         foreach ( $customer_orders as $customer_order ) {
                $order = new WC_Order($order_id);
 
                $order->populate( $customer_order );
 
                $status     = get_term_by( 'slug', $order->status, 'shop_order_status' );
                $item_count = $order->get_item_count();
if ($a == false){
 $a = $order->get_order_number();
}
return $a;
}
}
function wh_add_continue_shopping_button_to_cart() {
global $wh_shoppingpage;
$shop_page_url = get_home_url() . $wh_shoppingpage;
echo '<div class="wh_woocommerce"><div class="cart-collaterals"><div class="cart_totals">';
echo ' <a href="'.esc_html ($shop_page_url).'" class="button">Continue Shopping</a>';
echo '</div></div></div>';
}
add_action( 'woocommerce_after_cart_table', 'wh_add_continue_shopping_button_to_cart',20,2 );
function wh_send_domain_renew_emails()
{
global $woocommerce, $a, $order_id,$user_id;
global $numberofdays;
global $username;
global $domain;
global $product_name;
$customer_orders = get_posts( apply_filters( 'woocommerce_my_account_my_orders_query', array(
    'numberposts' => $order_count,
    'meta_key'    => '_customer_user',
    'meta_value'  => $customer_id,
    'post_type'   => 'shop_order',
    'post_status' => 'publish'
) ) );
         foreach ( $customer_orders as $customer_order ) 
	{
                $order = new WC_Order($order_id);
 
                $order->populate( $customer_order );
 
                $status     = get_term_by( 'slug', $order->status, 'shop_order_status' );
                $item_count = $order->get_item_count();
$user_id = $order->user_id;
$user_info = get_userdata($user_id);
$username = $user_info->first_name;
$paid = $customer_order->post_status;
	foreach($order->get_items() as $item) 
		{
	$product_name = $item['name'];
	$product_id = $item['product_id'];
	
	$domain = get_post_meta( $product_id, 'package',true);
	$domainreg = false;
	if (isset($domain) && ($domain == "domain") || ($domain == 'domain-renew'))
			{
		if (isset($paid) && ($paid == 'wc-completed'))
			{
			$expirydate = get_post_meta($product_id, 'domainexpiry',true);
			$days21 = date('d-m-Y', strtotime('+21 days'));
			$days14 = date('d-m-Y', strtotime('+14 days'));
			$days7 = date('d-m-Y', strtotime('+7 days'));
if ($expirydate == $days21){
$numberofdays = '21';
send_domain_renew_notice($numberofdays);
}
if ($expirydate == $days14){
$numberofdays = '14';
send_domain_renew_notice($numberofdays);
}
if ($expirydate == $days7){
$numberofdays = '7';
send_domain_renew_notice($numberofdays);
}
			
			
			}
			}
		}
	}
}
add_action('wh_send_domain_renew_emails','wh_send_domain_renew_emails');
function send_domain_renew_notice($numberofdays)
{
global $numberofdays,$user_id;
global $username;
global $domain;
global $product_name;
$imgurl = site_url();
$user_info = get_userdata($user_id);
$mail_to = $user_info->user_email;
$youremail = get_option( 'admin_email', $default );
$headers  = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
$headers .= 'From:' . $youremail . "\r\n";
$subject="Register Domain Notice" ;
$body_message = '<img src="' . plugins_url('/images/logo.png' , __FILE__ ) . '" alt="' . get_bloginfo() . '">';
$body_message .= '<br /><br />Dear ' . esc_html ($username) . '<br />';
$body_message .= 'Your Domain ' . esc_html ($product_name) . ' is due to be renewed in ' . esc_html ($numberofdays) . ' Days<br />';
$body_message .= 'You will receive additional reminders before the renew date</br />';
mail($mail_to, $subject, $body_message, $headers);  
}
function wh_show_tld_prices()
{
echo '<h2>Domain Prices</h2> <br />';
$count = '0';
do
{
$count++;
$s = get_option( 'wh_tld' . $count) ;
$data_tld1[$s] = get_option( 'wh_tld' . $count . 'price');
if ($s <> ''){
echo esc_html ($s) . '&nbsp;&nbsp;' . '&pound;' . esc_html ($data_tld1[$s]) . '<br />';
}
} while ($s <> '');
}
add_shortcode('wh_show_tld_prices','wh_show_tld_prices');
function wh_transfer_tld_prices()
{
echo '<br />';
$count = '0';
do
{
$count++;
$s = get_option( 'wh_tld' . $count) ;
$data_tld1[$s] = get_option( 'wh_tld' . $count . 'price');
if ($s <> ''){
echo esc_html ($s) . '&nbsp;&nbsp;' . '&pound;' . esc_html ($data_tld1[$s]) . '<br />';
}
} while ($s <> '');
}
add_shortcode('wh_transfer_tld_prices','wh_transfer_tld_prices');




function woo_get_order_id($order_id){
global $api_user_id,$api_key,$woocommerce,$orderid,$order_id,$domainresult,$product_name,$admin_id,
$wpdb,$product_id,$djgmessage,$httpResponse,$order,$djg_account_id,$accountpassword,$contact_type,
$customer_id,$user_id,$newdomain,$accountemail,$count,$a,$djg_userid,$ordernumber,$new_or_transfer,
$auth_code;
$orderid = $order;
$a = false;
$count = 0;
$customer_orders = get_posts( apply_filters( 'woocommerce_my_account_my_orders_query', array(
    'numberposts' => $order_count,
    'meta_key'    => '_customer_user',
    'meta_value'  => $customer_id,
    'post_type'   => 'shop_order',
    'post_status' => 'publish'
) ) );
         foreach ( $customer_orders as $customer_order ) {
                $order = new WC_Order($order_id);
                $order->populate( $customer_order );
                $status     = get_term_by( 'slug', $order->status, 'shop_order_status' );
                $item_count = $order->get_item_count();
		$a = $order->get_order_number();
		$order = new WC_Order($a);
		$paid = $order->post_status;
		$process = false;
		$process = get_post_meta($a,'order-processed',true);
	if (isset($paid) && ($paid == 'wc-completed') && ($process == false))
	{
	update_post_meta($a,'order-processed','1');
	set_transient('email_status', '0', 60*5); // this is for sending email at the bottom of this script
	$newdomain = get_post_meta($a, '_domain_field',true);
	if ($newdomain ==''){
	$newdomain = get_post_meta($a, '_wh_domainname_field',true);
	}
if ($newdomain ==''){
$newdomain = false;
		$items = $order->get_items();
		foreach ( $items as $item ) {
		$producttype = false;
		$product_name = $item['name'];
		$product_id = $item['product_id'];
		$producttype = get_post_meta( $product_id, 'package',true);
	if (isset($producttype) && ($producttype == "domain") || ($producttype == "domain-renew"))
			{
			$newdomain = $product_name;break;
			}
	
		}
}
$accountemail = $order->billing_email;
$items = $order->get_items();
$user_id = $order->user_id;
$id = $order->id;
$customer_id = $user_id ;
$invoice_type = get_post_meta($order->id, '_invoice_type', true);
$domain_renew = get_post_meta( $product_id, 'package', true );
if (($invoice_type == false) || ( $domain_renew == 'domain-renew')){
	foreach ( $items as $item ) {
		$producttype = false;
		$productid = false;
		$domainresult = false;
		$product_name = $item['name'];
		$productid = $item['product_id'];
		$product_id = $item['product_id'];		
		$producttype = get_post_meta( $productid, 'package',true);
		$domainreg = get_post_meta( $productid, 'domain-registered',true);
				
		if (isset($producttype) && ($producttype == "hosting") && ($newdomain <> false)){
WHM_create_account();
$wh_domainname = get_post_meta($a, '_domain_field',true);
update_post_meta($a, '_domain_field','');
update_post_meta($a, '_wh_domainname_field',$newdomain);
}
		if (isset($producttype) && ($producttype == "domain") || ($producttype == "domain-renew"))
{
	$domainreg = get_post_meta( $productid, 'domain-registered',true);
	$accountpassword = get_user_meta( $user_id, 'resellerclub_password', true );
		$key  = 'qJB0rGtIn5UB1xG03efyCp';
		$data = $accountpassword;
		$decrypted = decryptIt( $data,$key );
	$accountpassword = $decrypted;
$new_or_transfer = get_post_meta( $productid, 'new-or-transfer',true); // for transfer
$auth_code = get_post_meta( $productid, 'auth-code',true); // for transfer
	woo_resellerclub_signup($accountpassword, $djg_account_id, $customer_id, $domainresult, $ordernumber);
	if (isset($djg_account_id) && ($djg_account_id == true)) 
	{
	woo_get_resellerclub_customers_info($admin_id,$contact_type,$djg_account_id,$product_id,$customer_id);
	}
	if (isset($contact_type))
	{  
	woo_get_resellerclub_customers_id($admin_id,$contact_type,$djg_account_id,$product_id,$customer_id);
	}
 
	if (isset($admin_id) && ($admin_id <> '')) 
	{$ordernumber = false;
	woo_register_domain($admin_id, $product_name, $domainresult, $djgmessage, $product_id, $ordernumber);
	}
if ($new_or_transfer == 'new'){
wh_update_domains_after_order_status($order_id);
				if ($ordernumber == false)
				{
				
				}else {wh_update_domains_after_order_status($order_id);}
}
	} // end of if (isset($producttype) && ($producttype == "domain"))
} // end of foreach
} // end of if ($invoice_type == false)
} // end of (isset($paid)
} // end of foreach ( $customer_orders as $customer_order )
mail("admin@web-uk.co.uk","Result",'order number ' . $ordernumber);
} // end of function
add_action('woocommerce_order_status_completed','woo_get_order_id',10,1);


function wh_controlpanel(){
global $woocommerce;

if( wh_woocommerce_version_check() ) {
    ?>
<div class="wh_controlpanel">
<ul>
<li class="<?php echo wc_get_account_menu_item_classes( $endpoint ); ?>">
<a href="control-panel">Control Panel</a>
</li><ul></div> <?php
}
}
add_action('woocommerce_account_navigation','wh_controlpanel',10,1);


function wh_woocommerce_version_check($wooversion='2.5.0') {
  
  
    global $woocommerce,$wooversion;
   $wooversion = $woocommerce->version;

 if ($wooversion >= '2.6.0') {return true;
    } else
  {
  return false;
}


}
?>